// file:        ActionConstants.java
// source file: ActionConstants.java
// object file: ActionConstants.class
//
//
// included objects:
//  ActionConstants
//    Desc: includes all action constants necessary in the project 
//          and two conversion methods (action_string <-> value)
//
// history:
//   01.04.97 - first version finished by Roman Valehrach
//
// critical problems: none
//
// known problems: none
//


class ActionConstants extends Object {

// --- actions - String constansts: ---------------------------------------
  static final String STR_UP          = "UP";
  static final String STR_DOWN        = "DOWN";
  static final String STR_LEFT        = "LEFT";
  static final String STR_RIGHT       = "RIGHT";
 
  static final String STR_WAIT        = "WAIT";
  static final String STR_CLIMB       = "CLIMB";
  static final String STR_GRAB        = "GRAB";
 
  static final String STR_SUCK        = "SUCK";
  static final String STR_TURN_OFF    = "TURN_OFF";
 
  static final String STR_SHOOT_UP    = "SHOOT_UP";
  static final String STR_SHOOT_DOWN  = "SHOOT_DOWN";
  static final String STR_SHOOT_LEFT  = "SHOOT_LEFT";
  static final String STR_SHOOT_RIGHT = "SHOOT_RIGHT";


// --- actions - binary coded constansts: ---------------------------------
  static final int BASE  = 0x00;
  static final int UP          = 0x01 | BASE;
  static final int DOWN        = 0x02 | BASE;
  static final int LEFT        = 0x04 | BASE;
  static final int RIGHT       = 0x08 | BASE;

  static final int BASE2 = 0x10;
  static final int WAIT        = 0x00 | BASE2;
  static final int CLIMB       = 0x01 | BASE2;
  static final int GRAB        = 0x02 | BASE2;
  static final int SUCK        = 0x04 | BASE2;
  static final int TURN_OFF    = 0x08 | BASE2;

  static final int BASE3 = 0x20;
  static final int SHOOT = BASE3;
  static final int SHOOT_UP    = UP    | SHOOT;
  static final int SHOOT_DOWN  = DOWN  | SHOOT;
  static final int SHOOT_LEFT  = LEFT  | SHOOT;
  static final int SHOOT_RIGHT = RIGHT | SHOOT;

  static final int BASE4 = 0x40;

// public methods:
  public String action2String(int action)
  {
    switch(action)
    {
      case UP   :        return STR_UP;
      case DOWN :        return STR_DOWN;
      case LEFT :        return STR_LEFT;
      case RIGHT:        return STR_RIGHT;

      case CLIMB:        return STR_CLIMB;
      case GRAB :        return STR_GRAB;
      case WAIT :        return STR_WAIT;

      case SUCK    :     return STR_SUCK;
      case TURN_OFF:     return STR_TURN_OFF;

      case SHOOT_UP   :  return STR_SHOOT_UP;
      case SHOOT_DOWN :  return STR_SHOOT_DOWN;
      case SHOOT_LEFT :  return STR_SHOOT_LEFT;
      case SHOOT_RIGHT:  return STR_SHOOT_RIGHT;

      default:           return(null);
    }
  }


  public int String2action(String action)
  {
    if (action.equalsIgnoreCase(STR_UP))           return UP;
    if (action.equalsIgnoreCase(STR_DOWN))         return DOWN;
    if (action.equalsIgnoreCase(STR_LEFT))         return LEFT;
    if (action.equalsIgnoreCase(STR_RIGHT))        return RIGHT;

    if (action.equalsIgnoreCase(STR_CLIMB))        return CLIMB;
    if (action.equalsIgnoreCase(STR_GRAB))         return GRAB;
    if (action.equalsIgnoreCase(STR_WAIT))         return WAIT;

    if (action.equalsIgnoreCase(STR_SUCK))         return SUCK;
    if (action.equalsIgnoreCase(STR_TURN_OFF))     return TURN_OFF;

    if (action.equalsIgnoreCase(STR_SHOOT_UP))     return SHOOT_UP;
    if (action.equalsIgnoreCase(STR_SHOOT_DOWN))   return SHOOT_DOWN;
    if (action.equalsIgnoreCase(STR_SHOOT_LEFT))   return SHOOT_LEFT;
    if (action.equalsIgnoreCase(STR_SHOOT_RIGHT))  return SHOOT_RIGHT;

    return(0);
  }

} // End of Class ActionConstants
