import AgentField;

//
//
// AdvancedAgentField
//
// Extends its ancestor AgentField by adding support to memorize
// if a stench/breeze was percepted when visiting the field. This can
// be used for periodic field updating.
// The new members include methods to set their value and to return
// their values as strings.
//
//
//

class AdvancedAgentField extends AgentField
{
  private boolean hasstench;
  private boolean hasbreeze;

  public AdvancedAgentField() 
  {
    super();
    hasstench = false;
    hasbreeze = false;
  }

  public AdvancedAgentField( boolean wall, boolean pit, boolean wumpus, boolean exit, 
	                 boolean visited, boolean hasstench, boolean hasbreeze )
  {
	super( wall, pit, wumpus, exit, visited );
    this.hasstench = hasstench;
    this.hasbreeze = hasbreeze;
  }

  public String isStench()
  {
    if( hasstench == true )
      return "YES";
    else
      return "NO";
  }

  public void setStench( boolean newstench )
  {
    hasstench = newstench;
  }

  public String isBreeze()
  {
    if( hasbreeze == true )
      return "YES";
    else
      return "NO";
  }

  public void setBreeze( boolean newbreeze )
  {
    hasbreeze = newbreeze;
  }
}

