import AgentFieldList;

//
//
// AdvancedAgentFieldList
//
// Extends its ancestor AgentFieldList by adding support to memorize
// if a stench/breeze was percepted when visiting the field. This can
// be used for periodic field updating.
// The new members include methods to set their value and to return
// their values as strings.
//
//

class AdvancedAgentFieldList extends AgentFieldList
{
  private boolean hasstench;
  private boolean hasbreeze;

  public AdvancedAgentFieldList( int x, int y ) 
  {
    super( x, y );
    hasstench = false;
    hasbreeze = false;
  }

  public AdvancedAgentFieldList( boolean wall, boolean pit, boolean wumpus, boolean exit, 
	                 boolean visited, boolean hasstench, boolean hasbreeze, int x, int y )
  {
	super( wall, pit, wumpus, exit, visited, x, y );
    this.hasstench = hasstench;
    this.hasbreeze = hasbreeze;
  }

  public String isStench()
  {
    if( hasstench == true )
      return "YES";
    else
      return "NO";
  }

  public void setStench( boolean newstench )
  {
    hasstench = newstench;
  }

  public String isBreeze()
  {
    if( hasbreeze == true )
      return "YES";
    else
      return "NO";
  }

  public void setBreeze( boolean newbreeze )
  {
    hasbreeze = newbreeze;
  }

}

