import AdvancedAgentFieldList;

//
//
// AdvancedSearchAgentFieldList
//
// Field representation that allows an agent to store
// if it has been already 'visited' during a search;
//
// The new member includes a set and a get method to 
// store/retrieve its value.
//
//

class AdvancedSearchAgentFieldList extends AdvancedAgentFieldList
{
  protected boolean searched;

  AdvancedSearchAgentFieldList( int x, int y)
  {
    super( x, y );
    searched = false;
  }

  public AdvancedSearchAgentFieldList( boolean wall, boolean pit, boolean wumpus, boolean exit, 
	                 boolean visited, boolean hasstench, boolean hasbreeze, int x, int y )
  {
	super( wall, pit, wumpus, exit, visited, hasstench, hasbreeze, x, y );
    searched = false;  
  }

  public void setSearched( boolean newstate )
  {
    searched = newstate;
  }

  public boolean getSearched()
  {
    return searched;
  }

}

