import AdvancedSearchAgentField;
import java.awt.Point;

//
//
// AdvancedSearchBAgentField
//
// This field representation allows to keep of which
// node expanded this node during a search via the 
// parent member. For reconstructing a way from the
// current field to a serched field - or vice versa -
// a field must also know its coordinates which are
// stored in member me
// Both new members have their own get and set method with the
// set methods checking for valid inputs.
//
//

class AdvancedSearchBAgentField extends AdvancedSearchAgentField
{
  protected Point parent;
  protected Point me;

  public AdvancedSearchBAgentField()
  {
    super();
    searched = false;
    parent = new Point( -1, -1 );
    me = new Point( -1, -1 );
  }

  public AdvancedSearchBAgentField( boolean wall, boolean pit, boolean wumpus, boolean exit, 
	                 boolean visited, boolean hasstench, boolean hasbreeze, boolean searched,
                     Point ancestor, Point you )
  {
	super( wall, pit, wumpus, exit, visited, hasstench, hasbreeze );
    searched = false;  
    parent = new Point( -1, -1 );
    me = new Point( -1, -1 );

    if( ancestor.x >= 0 && ancestor.y >= 0 )
    {
      parent.x = ancestor.x;
      parent.y = ancestor.y;
    }

    if( you.x >= 0 && you.y >= 0 )
    {
      me.x = you.x;
      me.y = you.y;
    }
  }

  public void setParent( Point ancestor )
  {
    // points int the wumpus - domain must be in the range
    // [ 0..m ] / [ 0.. n ] to be valid; if invalid point - values
    // are passed, parent will be set to ( -1 / -1 )
    if( ancestor.x < 0 || ancestor.y < 0 )
    {
      parent.x = -1;
      parent.y = -1;
    }
    else
    {
      parent.x = ancestor.x;
      parent.y = ancestor.y;
    }
  }

  public Point getParent()
  {
    return parent;
  }

  public void setPlace( Point you )
  {
    // points int the wumpus - domain must be in the range
    // [ 0..m ] / [ 0.. n ] to be valid; if invalid point - values
    // are passed, parent will be set to ( -1 / -1 )
    if( you.x < 0 || you.y < 0 )
    {
      me.x = -1;
      me.y = -1;
    }
    else
    {
      me.x = you.x;
      me.y = you.y;
    }
  }

  public Point getPlace()
  {
    return me;
  }
}
