import AdvancedSearchAgentFieldList;
import java.awt.Point;

//
//
// AdvancedSearchBAgentFieldList
//
// This field representation allows to keep track of which
// node expanded this node during a search via the 
// parent member. For reconstructing a way from the
// current field to a serched field - or vice versa -
// a field must also know its coordinates which are
// stored in member me; this is already true for every 
// field list.
// The new member parent has a  get and set method with the
// set method checking for valid inputs.
// A new method getPlace() was added that returns a Point
// object of the fields coordinates.
//
//

class AdvancedSearchBAgentFieldList extends AdvancedSearchAgentFieldList
{

  protected Point parent;

  public AdvancedSearchBAgentFieldList( int x, int y)
  {
    super( x, y);
    searched = false;
    parent = new Point( -1, -1 );
  }

  public AdvancedSearchBAgentFieldList( boolean wall, boolean pit, boolean wumpus, boolean exit, 
	                 boolean visited, boolean hasstench, boolean hasbreeze, int x, int y,
                     boolean searched, Point ancestor )
  {
	super( wall, pit, wumpus, exit, visited, hasstench, hasbreeze, x, y );
    searched = false;  
    parent = new Point( -1, -1 );

    if( ancestor.x >= 0 && ancestor.y >= 0 )
    {
      parent.x = ancestor.x;
      parent.y = ancestor.y;
    }
  }

  public void setParent( Point ancestor )
  {
    // points int the wumpus - domain must be in the range
    // [ 0..m ] / [ 0.. n ] to be valid; if invalid point - values
    // are passed, parent will be set to ( -1 / -1 )
    if( ancestor.x < 0 || ancestor.y < 0 )
    {
      parent.x = -1;
      parent.y = -1;
    }
    else
    {
      parent.x = ancestor.x;
      parent.y = ancestor.y;
    }
  }

  public Point getParent()
  {
    return parent;
  }

  public Point getPlace()
  {
    return new Point( xcoord, ycoord );
  }
}

