

//
//
// AgentField
// simple represantation of a field in the wumpus environment
// only thos objects interesting for an agent are included (i.e. no gold)
// 12. 03. 1997 Christian Schwaiger
//
//

class AgentField 
{

  private boolean wall;
  private boolean pit;
  private boolean maybepit; 
  private boolean wumpus;
  private boolean maybewumpus;
  private boolean exit;
  private boolean visited;
  private int numberofvisits;


  // Two constructors are supplied:
  // One that sets every member to false and one
  // that accepts values for the members
  public AgentField() 
  {
    wall = false;
	pit = false;
	maybepit = true;
	wumpus = false;
	maybewumpus = true;
	exit = false;
	visited = false;
	numberofvisits = 0;
  }

  public AgentField( boolean wall, boolean pit, boolean wumpus, boolean exit, 
	                 boolean visited )
  {
	this.wall = wall;
	this.pit = pit;
	maybepit = false;
	this.wumpus = wumpus;
	maybewumpus = false;
	this.exit = exit;
	this.visited = visited;
	if( visited == true )
      numberofvisits = 1;
    else
      numberofvisits = 0;
  }

  // for every member two methods are supplied:
  // One that sets the member and the other
  // that returns a string specifying the state of the member
  public void setWall( boolean wall )
  {
	// may only change a field from not a wall to wall
	if( wall == true )
	{
	  this.wall = wall;
	  // wall implies no pit, no wumpus, no exit
	  pit = false;
	  maybepit = false;
	  wumpus = false;
	  maybewumpus = false;
	  exit = false;
	}
  }

  public String isWall()
  {
	 if( wall == true )
	   return "YES";
	 else
	   return "NO";
  }

  public void setPit( boolean pit )
  {
	this.pit = pit;
	maybepit = false;
  }

  public String hasPit()
  {
	if( pit == true )
	  return "YES";
	else if( pit == false & maybepit == true )
	  return "MAYBE";
	else 
	  return "NO";
  }


  public void setWumpus( boolean wumpus )
  {
	this.wumpus = wumpus;
	maybewumpus = false;
  }

  public String hasWumpus()
  {
	if( wumpus == true )
	  return "YES";
	else if( wumpus == false & maybewumpus == true )
	  return "MAYBE";
	else 
	  return "NO";
  }
			   
  public void setExit( boolean exit ) 
  {
	this.exit = exit;
  }

  public String isExit()
  {
	if( exit == true )
	  return "YES";
	else
	  return "NO";
  }

  public void setVisited( boolean visited ) 
  {
	this.visited = visited;
  }

  public String wasVisited()
  {
	if( visited == true )
	  return "YES";
	else
	  return "NO";
  }

  public void incVisited()
  {
	numberofvisits++;
  }

  public int visitCount()
  {
	return numberofvisits;
  }

}

