import ArraySearchBackWumpus;
import java.util.*;
import java.awt.*;
import java.awt.image.ImageObserver;

//
//
// ArrayBreathWumpus searches for a way home as soon as it finds gold; 
// it uses breadth first search; the nodes that are expanded are added
// to the queaue with the one with the smallest manhatten - distance to
//  the home - field first.
// ( this is also called  a 'greedy' search algorithm ) 
//
// It is slightly 'goal - based': if gold was found it returns home
// immediatly
//
//

class ArrayBreadthWumpus extends ArraySearchBackWumpus
{
  static final String type = "ARRAYBREADTHWUMPUS";

  protected Vector searchqueue;
  protected AdvancedSearchBAgentField myfield[] [];

  public ArrayBreadthWumpus( String name, int ammo, Dimension size )
  {
    this( name, ammo, false, size, ( String ) null, ( ImageObserver ) null, type );
  }
 
  public ArrayBreadthWumpus( String name, int ammo, boolean takerisk, Dimension size )
  {
    this( name, ammo, takerisk, size, ( String ) null, ( ImageObserver ) null, type );
  }
 
  public ArrayBreadthWumpus( String name, int ammo, Dimension size, String imgref )
  {
    this( name, ammo, false, size, imgref, ( ImageObserver ) null, type );
  }

  public ArrayBreadthWumpus( String name, int ammo, Dimension size, ImageObserver obs )
  {
    this( name, ammo, false, size, ( String ) null, obs, type );
  }

  public ArrayBreadthWumpus( String name, int ammo, boolean takerisk,Dimension size,
                                String imgref, ImageObserver obs )
  {
    this( name, ammo, takerisk, size, imgref, obs, type );
  }
 
  public ArrayBreadthWumpus( String name, int ammo, boolean takerisk,Dimension size,
                                String imgref, ImageObserver obs, String type )
  {
    super( name, ammo, takerisk, size, imgref, obs, type );
  }// End of ArrayBreadthWumpus-Constructors

  protected void initField( Dimension fieldsize )
  {
    // initialize the field - represantation
	myfield = new AdvancedSearchBAgentField [ fieldsize.width ] [ fieldsize.height ];
    if( log == true )
    {
      System.out.println("ArraySearchBack: width = " + fieldsize.width);
      System.out.println("ArraySearchBack: height = " + fieldsize.height);
      System.out.println("ArraySearchBack: allocating myfield");
    }

    for( int i = 0; i < myfield.length; i++ )
	{
	  for( int j = 0; j < myfield[ i ].length; j++ )
	  {
		myfield[ i ] [ j ] = new AdvancedSearchBAgentField();
        if( log == true )
        {
          System.out.println("allocated myfield" + i + j );
        }
        myfield[ i ] [ j ].setParent( new Point( -1, -1 ) );
        myfield[ i ] [ j ].setPlace( new Point( i, j ) );
	  }
	}
    
    if( log == true )
    {
      System.out.println("finished field allocation");
    }
	// Agents start at location ( 1, 1 ); this is also the exit
    location = new Point( 1, 1);

    // do still assign x, y their coordinates for clarity
    location.x = 1;
	location.y = 1;
	myfield[ location.x ] [ location.y ].setExit( true );
	myfield[ location.x ] [ location.y ].setVisited( true );
    myfield[ location.x ] [ location.y ].setWumpus( false );
    myfield[ location.x ] [ location.y ].setPit( false );
	myfield[ location.x ] [ location.y ].incVisited();
    
    // up and left are wall because we always start in the upper left corner
    // this has to be removed if the agent should start anywhere in the maze
    myfield[ location.x - 1 ] [ location.y ].setWall( true );
    myfield[ location.x ] [ location.y - 1 ].setWall( true );
    
    // to be able to use methods from super - classes shadowed var must
    // be 'initialized' here 
    super.myfield = myfield; // for arraybackwumpus
    ( ( ArrayBackWumpus ) this ).myfield = this.myfield; 
    ( ( ArrayWumpus ) this ).myfield = this.myfield; // for arraywumpus
  }

  protected void finalize()
  {
    super.finalize();
    myfield = null;
    searchway = null;
  }
  
  protected boolean search( Point recent )
  {
    Point found;
    boolean success;
    success = false;
    searchqueue = new Vector( 5, 5 );
    found = searchBreadth( recent );
    if( found.x >= 0 && found.y >= 0 )
    {
      searchway = generateWay( found, recent );
      success = true;
    }
    return success;
  }

  protected Point searchBreadth( Point recent )
  {
    Vector nearestlast;
    Point workpoint, failed;
    AdvancedSearchBAgentField help, up, down, left, right, next;
    Point cup, cdown, cleft, cright;
    boolean found;
     
    found = false;
    failed = new Point( -1, -1 );

    help = myfield[ recent.x ] [ recent.y ];
    if( log == true )
    {
      System.out.println( "Starting breadth first search at: " + recent.x + "/" + recent.y );
    }

    // check starting field 
    if( help.isExit().equals( "YES" ) )
    {
      return recent;
    }

    // put starting point in Vector - ' queue '
    // and mark  it as worked
    help.setSearched( true );
    searchqueue.addElement( ( Object ) help );

    // initialize vector to four element - size
    nearestlast = new Vector( 4 ); 

    do
    {
      // get first Element and remove it from queue
      recent = ( ( AdvancedSearchBAgentField ) searchqueue.firstElement() ).getPlace();    
      searchqueue.removeElementAt( 0 );
      if( log == true )
      {
        System.out.println( "Got Point from queue: " + recent.x + "/" + recent.y );
        System.out.println( "Checking for exit" );
      }

      if( myfield[ recent.x ] [ recent.y ].isExit().equals( "YES" ) )
      {
        if( log == true )
        {
          System.out.println( "Field is exit" );
        }
        found = true;
      }
      else
      {
        if( log == true )
        {
          System.out.println( "Field is not exit" );
        }
      }
      
      // get neighbour coordinates
      up    =  myfield[ recent.x ] [ recent.y - 1 ];
      if( up.getSearched() == false )
      {
        up.setParent( recent );
      }
      down  =  myfield[ recent.x ] [ recent.y + 1 ];
      if( down.getSearched() == false)
      {
        down.setParent (recent ); 
      }
      left  =  myfield[ recent.x - 1 ] [ recent.y ];
      if( left.getSearched() == false )
      {
        left.setParent( recent );
      }
      right =  myfield[ recent.x + 1 ] [ recent.y ];
      if( right.getSearched() == false )
      {
        right.setParent( recent );
      }

      // get neighbour coordinates
      cup    = new Point( recent.x, recent.y - 1 );
      cdown  = new Point( recent.x, recent.y + 1 );
      cleft  = new Point( recent.x - 1, recent.y );
      cright = new Point( recent.x + 1, recent.y );

      // calculate manhatten - distance
      nearestlast = calcManhatten( cup, cdown, cleft, cright );
     
      // put them on the queue if they are not already there
      // and if they have been visited at least once
      for( int i = 0; i < nearestlast.size(); i++ )
      {
        workpoint = ( Point ) nearestlast.elementAt( nearestlast.size() - i - 1 ); 
        help = myfield[ workpoint.x ] [ workpoint.y ];
        if( help.wasVisited().equals( "YES" ) )
        {
          if( help.getSearched() == false )
          {
            help.setSearched( true );
            searchqueue.addElement( ( Object ) help );
          }
        }
      }
    } while ( searchqueue.isEmpty() == false && found == false );

    if( found == true )
    {
      return recent;
    }
    else
    {
      return failed;
    }
  }
  
  protected Vector generateWay( Point goal, Point first )
  {
    Vector path;
    Point parent, start, work;
    AdvancedSearchBAgentField help;
    
    path = new Vector( 5, 5 );
    start = first;
    work = goal;
    if( log == true )
    {
      System.out.println( "Generating way home starting with: " + work.x + "/" + work.y + "\n" );
    }

    do
    {
       help = myfield[ work.x ] [ work.y ];
       parent = help.getParent();
       if( log == true )
       {
         System.out.println(" Generate way recent: " + work.x + "/" + work.y );
         System.out.println(" Generate way parent: " + parent.x + "/" + parent.y );
       }

       if( ( parent.x == work.x ) && ( parent.y == work.y - 1 ) )
       {
         path.insertElementAt( new Action( "Down" ), 0 );
       }
       else if( ( parent.x == work.x ) && ( parent.y == work.y + 1 ) )
       {
         path.insertElementAt( new Action( "Up" ), 0 );
       }
       else if( ( parent.x == work.x - 1 ) && ( parent.y == work.y ) )
       {
         path.insertElementAt( new Action( "Right" ), 0 );
       }
       else if( ( parent.x == work.x + 1 ) && ( parent.y == work.y ) )
       {
         path.insertElementAt( new Action( "Left" ), 0 );
       }
       else // an error has happend
       {
         if( log == true )
         {
           System.out.println( "GenerateWay: Should never be here!" );
         }
         return path;
       }
       work = parent;
       if( log == true )
       {
         System.out.println( "Way generation continues with: " + work.x + "/" + work.y );
       }
       if( path.isEmpty() == false )
       {
         for( int i = 0; i < path.size(); i++ )
         if( log == true )
         {
           System.out.println( "path[ " + i + " ] is: " + ( ( Action )path.elementAt( i ) ).getName() );
         }
       }
    }while ( work.x != first.x || work.y != first.y );
    return path;
  }
}
