import ArrayBreadthWumpus;
import java.util.*;
import java.awt.*;
import java.awt.image.ImageObserver;

//
//
// ArrayMasterWumpus has the strategy of visiting every field
// it possibly can before returning home, hoping to find 
// all the gold that lies around in the maze.
// If the reason strategy it has inherited from its ancestors
// returns a move to an already visited field it searches to
// the nearest field that has not yet been visited and goes
// there.
// The search algorithm it uses for this purpose is
// breadth first search.
//
//

class ArrayMasterWumpus extends ArrayBreadthWumpus
{
  static final String type = "ARRAYMASTERWUMPUS";
  Vector waytonextfield;
  boolean gethome;

  public ArrayMasterWumpus( String name, int ammo, Dimension size )
  {
    this( name, ammo, false, size, ( String ) null, ( ImageObserver ) null, type );
  }
 
  public ArrayMasterWumpus( String name, int ammo, boolean takerisk, Dimension size )
  {
    this( name, ammo, takerisk, size, ( String ) null, ( ImageObserver ) null, type );
  }
 
  public ArrayMasterWumpus( String name, int ammo, Dimension size, String imgref )
  {
    this( name, ammo, false, size, imgref, ( ImageObserver ) null, type );
  }

  public ArrayMasterWumpus( String name, int ammo, Dimension size, ImageObserver obs )
  {
    this( name, ammo, false, size, ( String ) null, obs, type );
  }

  public ArrayMasterWumpus( String name, int ammo, boolean takerisk,Dimension size,
                                String imgref, ImageObserver obs )
  {
    this( name, ammo, takerisk, size, imgref, obs, type );
  }

  public ArrayMasterWumpus( String name, int ammo, boolean takerisk,Dimension size,
                                String imgref, ImageObserver obs, String type )
  {
    super( name, ammo, takerisk, size, imgref, obs, type );
  }// End of ArrayMasterWumpus-Constructors

  protected void initVars()
  {
    super.initVars();
    if( log == true )
    {
      System.out.println(" ArrayMaster: initializing new vars ");
    }
    waytonextfield = new Vector( 5, 5 );
    gethome = false;
  }
    
    
  protected void finalize()
  {
    super.finalize();
    waytonextfield = null;
  }
  
  protected void reason()
  {
    boolean search, helpback;
    search = false; 
    helpback = false;

    if( gohome == true && gethome == false )
    {
      gohome = false;
      if( log == true )
      {
        System.out.println( "Master: resetting gohome to: " + gohome );
        System.out.println( "I rather search for a new field to visit than going home" );
      }
    }
    
    // check waytonextfield vector for actions
    if( waytonextfield.isEmpty() == false )
    {
      if( log == true )
      {
        for( int i = waytonextfield.size() - 1; i >= 0; i-- )
        {
          System.out.println( "waytonextfield " + i + " is: " + ( ( Action ) waytonextfield.elementAt( i ) ).getName() );
        }
      }
      actions.addElement( waytonextfield.lastElement() );
      waytonextfield.removeElementAt( waytonextfield.size() - 1 );
      return;
    }

    super.reason(); 
    
    if( actions.isEmpty() == false && gethome == false )
    {
      gohome = false;
      String help = ( ( Action ) actions.firstElement() ).getName();
      
      // if a gold is on the first field we do not want to climb
      if( help.equals( "Climb" ) == true && moves == 2 )
      {
        search = searchNextVisit( location );
        if( search == true )
        {
          actions.removeAllElements();
          actions.addElement( waytonextfield.lastElement() );
          waytonextfield.removeElementAt( waytonextfield.size() - 1 );
        }
        else if( pickedgold == true )
        {
          updateWayBack();
          gethome = true;
          gohome = true;
          printField();
        }
      }

      if( help.equals( "Right" ) == true )
      {
        if( myfield[ location.x + 1 ] [ location.y ].wasVisited().equals( "YES" ) )
        {
          search = searchNextVisit( location );
          if( search == true )
          {
            actions.removeAllElements();
            actions.addElement( waytonextfield.lastElement() );
            waytonextfield.removeElementAt( waytonextfield.size() - 1 );
          }
          else if( pickedgold == true )
          {
            updateWayBack();
            gethome = true;
            gohome = true;
            printField();
          }
        }
      }
      if( help.equals( "Left" ) == true )
      {
        if( myfield[ location.x - 1 ] [ location.y ].wasVisited().equals( "YES" ) )
        {
          search = searchNextVisit( location );
          if( search == true )
          {
            actions.removeAllElements();
            actions.addElement( waytonextfield.lastElement() );
            waytonextfield.removeElementAt( waytonextfield.size() - 1 );
          }
          else if( pickedgold == true )
          {
            updateWayBack();
            gethome = true;
            gohome = true;
            printField();
          }
        }
      }
      if( help.equals( "Up" ) == true )
      {
        if( myfield[ location.x ] [ location.y - 1 ].wasVisited().equals( "YES" ) )
        {
          search = searchNextVisit( location );
          if( search == true )
          {
            actions.removeAllElements();
            actions.addElement( waytonextfield.lastElement() );
            waytonextfield.removeElementAt( waytonextfield.size() - 1 );
          }
          else if( pickedgold == true )
          {
            updateWayBack();
            gethome = true;
            gohome = true;
            printField();
          }
        }
      }
      if( help.equals( "Down" ) == true )
      {
        if( myfield[ location.x ] [ location.y +1 ].wasVisited().equals( "YES" ) )
        {
          search = searchNextVisit( location );
          if( search == true )
          {
            actions.removeAllElements();
            actions.addElement( waytonextfield.lastElement() );
            waytonextfield.removeElementAt( waytonextfield.size() - 1 );
          }
          else if( pickedgold == true )
          {
            updateWayBack();
            gethome = true;
            gohome = true;
            printField();
          }
        }
      }
    }
  }

  protected boolean searchNextVisit( Point recent )
  {
    Vector help;
    Point found;
    boolean success;
    success = false;
    help = new Vector( 5, 5 );
    searchqueue = new Vector( 5, 5 );
    
    for( int i = 0; i < myfield.length; i++ )
	{
	  for( int j = 0; j < myfield[ i ].length; j++ )
	  {
		myfield[ i ] [ j ].setSearched( false );
        myfield[ i ] [ j ].setParent( new Point( -1, -1 ) );
	  }
	}

    found = searchBreadthNext( recent, false );
    if( found.x >= 0 && found.y >= 0 )
    {
      help = generateWay( found, recent );
      for( int i = 0; i < help.size(); i++ )
      {
        waytonextfield.addElement( help.elementAt( help.size() - i - 1 ) );
      }
      success = true;
    }
    else if( takerisk == true )
    {
      for( int i = 0; i < myfield.length; i++ )
      {
	    for( int j = 0; j < myfield[ i ].length; j++ )
        {
		  myfield[ i ] [ j ].setSearched( false );
          myfield[ i ] [ j ].setParent( new Point( -1, -1 ) );
        }
      }

      searchqueue.removeAllElements();
      found = searchBreadthNext( recent, true );
      if( found.x >= 0 && found.y >= 0 )
      {
        help = generateWay( found, recent );
        for( int i = 0; i < help.size(); i++ )
        {
          waytonextfield.addElement( help.elementAt( help.size() - i - 1 ) );
        }
        success = true;
      }
    }
    searchqueue.removeAllElements();

    for( int i = 0; i < myfield.length; i++ )
	{
	  for( int j = 0; j < myfield[ i ].length; j++ )
	  {
		myfield[ i ] [ j ].setSearched( false );
        myfield[ i ] [ j ].setParent( new Point( -1, -1 ) );
	  }
	}

    if( log == true )
    {
      System.out.println(" returning success: " + success );
    }
    return success;
  }

  protected Point searchBreadthNext( Point recent, boolean dare )
  {
    Point workpoint, failed;
    AdvancedSearchBAgentField help, up, down, left, right, next;
    Point cup, cdown, cleft, cright;
    boolean found;
     
    found = false;
    failed = new Point( -1, -1 );

    help = myfield[ recent.x ] [ recent.y ];
    if( log == true )
    {
      System.out.println( "Starting search at: " + recent.x + "/" + recent.y );
    }

    // put starting point in Vector - ' queue '
    // and mark  it as worked
    help.setSearched( true );
    searchqueue.addElement( ( Object ) help );

    do
    {
      // get first Element and remove it from queue
      recent = ( ( AdvancedSearchBAgentField ) searchqueue.firstElement() ).getPlace();    
      searchqueue.removeElementAt( 0 );
      if( log == true )
      {
        System.out.println( "Got Point from queue: " + recent.x + "/" + recent.y );
        System.out.println( "Checking for goal - field" );
      }
      if( dare == false )
      {
        if( myfield[ recent.x ] [ recent.y ].wasVisited().equals( "NO" ) &&
            myfield[ recent.x ] [ recent.y ].hasWumpus().equals( "NO" ) &&
            myfield[ recent.x ] [ recent.y ].hasPit().equals( "NO" )  &&
            myfield[ recent.x ] [ recent.y ].isWall().equals( "NO" ) )
        {
          if( log == true )
          {
            System.out.println( "Found TARGET field no daring" );
          }
          found = true;
        }
        else
        {
          if( log == true )
          {
            System.out.println( "Field is of no interest no daring" );
          }
        }
      }
      else if( myfield[ recent.x ] [ recent.y ].wasVisited().equals( "NO" ) &&
               ( myfield[ recent.x ] [ recent.y ].hasWumpus().equals( "MAYBE" ) || 
                 myfield[ recent.x ] [ recent.y ].hasWumpus().equals( "NO" )  ) &&
               ( myfield[ recent.x ] [ recent.y ].hasPit().equals( "MAYBE" ) || 
                 myfield[ recent.x ] [ recent.y ].hasPit().equals( "NO" ) ) && 
               myfield[ recent.x ] [ recent.y ].isWall().equals( "NO" ) )
      {
        if( log == true )
        {
          System.out.println( "Found TARGET field daring" );
        }
        found = true;
      }
      else
      {
        if( log == true )
        {
          System.out.println( "Field is of no interest daring" );
        }
      }
      
      // get neighbour coordinates if no goal field has been found yet
      // also check if this is a save field; only then add its neighbours to the queue
      if( found == false && myfield[ recent.x ] [ recent.y ].hasWumpus().equals( "NO" )  && 
          myfield[ recent.x ] [ recent.y ].hasPit().equals( "NO" )  && myfield[ recent.x ] [ recent.y ].isWall().equals( "NO" ) )
          
      {
        cup    = new Point( recent.x, recent.y - 1 );
        cdown  = new Point( recent.x, recent.y + 1 );
        cleft  = new Point( recent.x - 1, recent.y );
        cright = new Point( recent.x + 1, recent.y );

        if( ( cright.x >= 0 && cright.y >= 0 ) && ( cright.x < myfield.length && cright.y < myfield[ cright.x ].length ) )
        {  
           right =  myfield[ recent.x + 1 ] [ recent.y ];
          if( right.getSearched() == false )
          {
            right.setParent( recent );
            right.setSearched( true );
            searchqueue.addElement( ( Object ) right );
          }
        }
        if( ( cup.x >= 0 && cup.y >= 0 ) && ( cup.x < myfield.length && cup.y < myfield[ cup.x ].length ) )
        {  
          up    =  myfield[ recent.x ] [ recent.y - 1 ];
          if( up.getSearched() == false )
          {
            up.setParent( recent );
            up.setSearched( true );
            searchqueue.addElement( ( Object ) up );
          }
        }
        if( ( cleft.x >= 0 && cleft.y >= 0 ) && ( cleft.x < myfield.length && cleft.y < myfield[ cleft.x ].length ) )
        {  
          left  =  myfield[ recent.x - 1 ] [ recent.y ];
          if( left.getSearched() == false )
          { 
            left.setParent( recent );
            left.setSearched( true );
            searchqueue.addElement( ( Object ) left );
          }
        }
        if( ( cdown.x >= 0 && cdown.y >= 0 ) && ( cdown.x < myfield.length && cdown.y < myfield[ cdown.x ].length ) )
        {
          down  =  myfield[ recent.x ] [ recent.y + 1 ];
          if( down.getSearched() == false )
          {
            down.setParent (recent ); 
            down.setSearched( true );
            searchqueue.addElement( ( Object ) down );
          }
        }
      }
    } while ( searchqueue.isEmpty() == false && found == false );

    if( found == true )
    {
      return recent;
    }
    else
    {
      return failed;
    }
  } 

  protected void printField()
  {
    if( log == true )
    {
      for( int i = 0; i < myfield.length; i++ )
      {
	    for( int j = 0; j < myfield[ i ].length; j++ )
        {
	      System.out.println("myfield[ " + i + " ] [ " + j + " ] ");
          System.out.println("IsExit: " + myfield[ i ] [ j ].isExit() );
          System.out.println("HasWumpus: " + myfield[ i ] [ j ].hasWumpus() );
          System.out.println("HasPit: " + myfield[ i ] [ j ].hasPit() );
          System.out.println("IsWall: " + myfield[ i ] [ j ].isWall() );
          System.out.println("WasVisited: " + myfield[ i ] [ j ].wasVisited() );
        }
      }
    }
  }
}
