// Class Environment
// Author: ALOBA Babatope
//         Technical University of Vienna
//
// Creation Date: Nov 1996
//
// last modified: December through February 1997
//      *main coding Phase
//

import java.awt.*;


abstract class Environment  implements Drawable {
   //Superclass providing a uniform interface to all environments,
   //from the viewpoint of the world.

	//Variables:
	//-------------------------
	public String name; // unique identifier
	public int status[] = new int[3];
		// Status variable used by Environment and World.
		// [0]:	0 .. active
		//	1 .. finished/completed
		// [1]: Unused
		// [2]:Unused 

	String[][] envparam;

	//Methods:
	//-------------------------
		public Environment(String n, String[][] ep) {
			// parses parameterstring envparam
			name = n;
			envparam = ep;
			status[0] = 0;
                } //End constructor
      



		abstract void doOneStep();

			// Environment and all its ActiveObjects perform one
                        // move each. doOneStep calls the functions:
 			// sendPercept(); - which calls up ActiveObject.
 			// receive Percept &
 			// getAction(); - which calls up ActiveObject.
 			// sendAction();

 		abstract Dimension getMinSize() ;

		public void paintAll() {
			// All methods of interface drawable
			// must be implemented
                        //hence empty function
                } //End paintAll()


		public void setArea(Rectangle area, Graphics g) {
			// All methods of interface drawable
			// must be implemented
                        //hence empty function
                } //End setArea()

} //End Environment

