// file:        Exit.java
// source file: Exit.java
// object file: Exit.class
//
//
// included objects:
//  Exit
//    Desc: implements the base object - exit, which is a sign for the
//          caves exit
//          only at the caves exit the agents may leave (climb) the 
//          Wumpus-World
//
//
// history:
//   14.04.97 - first version finished by Roman Valehrach
//
//
// critical problems: none
//
// known problems: none
//

import java.awt.*;
import java.awt.image.ImageObserver;
import java.util.*;
import java.lang.*;

class Exit extends FieldBaseObject
{
  // private final static boolean DEBUG = false;

  // ahead defininitions:
  private final static String TYPE_EXIT = "EXIT";

  private final static String DEFAULT_COLOR_STR = "colors.fieldobject.EXITCOLOR";


// Method: Exit Constructor (public)
//
// *Purpose   : intializes a new instance and sets a new image (-resource)
//              for the object
//
// *Parameters: resource (String) - name of the new instance
//              resource (String) - name of the resource for the FieldObject
//              observer (ImageObserver) - observer for the FieldObject
//
// *Return    : none
//
// *Variables : none
//
//   with set/get-methods:
//              resoure (String) - default reference to an imagemap
//              obs (ImageObserver) - observer for the image
//
  public Exit( String resource, ImageObserver observer )
  {
    super( TYPE_EXIT, TYPE_EXIT, resource, observer );
  }

  public Exit( String resource )
  {
    super( TYPE_EXIT, TYPE_EXIT, resource );
  }

  public Exit( ImageObserver observer )
  {
    super( TYPE_EXIT, TYPE_EXIT, observer );
  }

  public Exit()
  {
    super( TYPE_EXIT, TYPE_EXIT );
  }

// Method: defaultColorName  (protected)
//
// *Purpose   : returns a default property identifing string for a 
//              resource and color (mostl often the only *NEW* things
//              - good for beeing overwritten by subclasses to set an other
//                default property identifing string 
//                (the string to be looked up in the system-property list
//
// *Parameters: none
//
// *Return    : String - the new default reource ot color
//
// *Variables : all the nessessary id-strings
//
  public String defaultColorName() { return DEFAULT_COLOR_STR; }


// Method: getDisplayName() (public)
//
// *Purpose   : statically returns the "Exit" string
//
// *Parameters: none
//
// *Return    : String - the current type, name or "Exit"
//
// *Variables : none
//
  public String getDisplayName()
  {
    return "Exit";
  }


/*
  public String vaidateFieldObjectAction ( FieldObject fldobj )
  {
    if there is a Climb in action return TRUE through "CLIMB"

    if there is no Climb.. this object cant handle it..
  }
*/
}// End of class Exit
