// file:        FieldBaseObject.java
// source file: FieldBaseObject.java
// object file: FieldBaseObject.class
//
//
// included objects:
//  FieldBaseObject
//    Desc: implements an object that represents the Fields base Object
//
//
// history:
//   14.04.97 - first version finished by Roman Valehrach
//
//
// critical problems: none
//
// known problems: none
//
 
import java.awt.*;
import java.awt.image.ImageObserver;
import java.util.*;
import java.lang.*;

abstract class FieldBaseObject extends FieldObject
{
 
// Method: FieldBaseObject Constructor (public)
//
// *Purpose   : intializes a new instance and sets a new image(-resource)
//              for the object
//
// *Parameters: name (String) - name of the new instance
//              type (String) - general type of the new instance
//              resource (String) - name of the resource for the FieldObject
//              observer (ImageObserver) - observer for the FieldObject
//
// *Return    : none
// *Variables : none
//
  public FieldBaseObject( String name, String type, String resource,
    ImageObserver observer )
  {
    super( name, type, resource, observer );
  }
  
  public FieldBaseObject( String name, String type, String resource )
  {
    super( name, type, resource, null );
  }
  
  public FieldBaseObject( String name, String type, ImageObserver observer )
  {
    super( name, type, null, observer );
  }
  
  public FieldBaseObject( String name, String type )
  {
    super( name, type, null, null );
  }

/*
// Method: fillsField (public)
//
// *Purpose   : returns whether the current object is as big a the
//              field (i.e. a Wall, Pit etc.) of a Field
//
// *Parameters: none
//
// *Return    : boolean - true when fields base
//
// *Variables : none
//
  public boolean fillsField()
  {
    return true;
  }

  public String vaidateFieldObjectAction ( FieldObject fldobj )
  {
    if there is a step into it's ok in case of a PIT... 
      WALLs return => BUMP

    if there is no MOVE_.... .. this object can't handle it..
  }

  public boolean leaveAble()
  {
    return false; // if it is a Wall, Pit ....
  }
*/
}//End of FieldBaseObject
