//
//
// HashList
//
// Array of slots elements with multiple matching entries
// linked together ( outer linked chain hash - table )
//
//
class HashList 
{
  private final int slots = 101;
  private final int sizey = 21;
  private int nrofentries;
  private AgentFieldList table[];
  private boolean log;

  public HashList()
  {
	nrofentries = 0;
    log = false;
	table =  new AgentFieldList[ slots ];
    for( int i = 0; i < table.length; i++ )
	{
	  table[ i ] = null;
      if( log == true )
      {
        System.out.println( " Created table index: " + i );
      }
	}
  }

  private int hash( int x, int y )
  {
	int hashvalue;
	int z;
	z = x * sizey + y + 1;
	hashvalue = ( z - 1 ) % slots ;
	return hashvalue;
  }

  public void addElement( AgentFieldList toadd )
  {
	// insert each element at the beginning of the list
	int index;
    if( log == true )
    {
      System.out.println( " Trying to hash: " + toadd.xcoord + " " + toadd.ycoord );
    }
	index = hash( toadd.xcoord, toadd.ycoord );
    
    if( index < 0 || index > ( slots -1 ) )
    {
      if( log == true )
      {
        System.out.println( " Hashed to invalid value. Doing nothing. " );
      }
    }
    else
    {
      if( log == true )
      {
        System.out.println( " Hashed to field number: " + index );
        System.out.println( " Adding element now." );
      }
      if( table[ index ] != null )
      {
	    toadd.next = table[ index ];
      }
	  table[ index ] = toadd;
    }
  }

  public AgentFieldList getElement( int x, int y )
  {
    int index;
    int depth = 0;
	boolean done = false;
	AgentFieldList help;
    help = null;
	index = hash( x , y );
    if( index < 0 || index > ( slots -1 ) )
    {
      if( log == true )
      {
        System.out.println( " Hashed to invalid value. Doing nothing. " );
      }
    }
    else
    {
      if( log == true )
      {
        System.out.println( " Hashed to field number: " + index );
      }
      if( table[ index ] == null )
      {
        if( log == true )
        {
          System.out.println( "This field is not yet existent." );
        }
        return null;
      }
	  else help = table[ index ];
	  while( help != null & done == false )
      {
    	if( help.xcoord == x && help.ycoord == y )
        {
          if( log == true )
          {
            System.out.println( "Retrieved field. Returning it now" );
          }
	      done = true;
        }
	    else
	      help = help.next;
        depth++;
      }
    }
    if( help == null )
    {
      if( log == true )
      {
        System.out.println( "This field is not yet existent." );
        System.out.println( "I have nothing to return." );
      }
    }
	return help;
  }

  public void setLog( boolean change )
  {
    if( log != change )
    {
      if( change == true )
      {
        System.out.println( "Logging now enabled" );
        log = change;
      }
      else
      {
        System.out.println( "Logging now disabled" );
        log = change;
      }
    }
  }
}

