import HashBreadthWumpus;
import java.util.*;
import java.awt.*;
import java.awt.image.ImageObserver;

//
//
// HashMasterWumpus has the strategy of visiting every field
// it possibly can before returning home, hoping to find 
// all the gold that lies around in the maze.
// If the reason strategy it has inherited from its ancestors
// returns a move to an already visited field it searches to
// the nearest field that has not yet been visited and goes
// there.
// The search algorithm it uses for this purpose is
// breadth first search.
//
//

class HashMasterWumpus extends HashBreadthWumpus
{
  static final String type = "HASHMASTERWUMPUS";

  Vector waytonextfield;
  boolean gethome;

  public HashMasterWumpus( String name, int ammo, Dimension size )
  {
    this( name, ammo, size, ( String ) null, ( ImageObserver ) null, type );
  }
 
  public HashMasterWumpus( String name, int ammo, Dimension size, String imgref )
  {
    this( name, ammo, size, imgref, ( ImageObserver ) null, type );
  }

  public HashMasterWumpus( String name, int ammo, Dimension size, ImageObserver obs )
  {
    this( name, ammo, size, ( String ) null, obs, type );
  }

  public HashMasterWumpus( String name, int ammo, Dimension size, String imgref, ImageObserver obs )
  {
    this( name, ammo, size, imgref, obs, type );
  }

  public HashMasterWumpus( String name, int ammo, Dimension size, String imgref, ImageObserver obs, String type )
  {
    super( name, ammo, size, imgref, obs, type);
  }// End of HashMasterWumpus-Constructorsors

  protected void initVars()
  {
    super.initVars();
    if( log == true )
    {
      System.out.println(" HashMaster: initializing new vars ");
    }
    waytonextfield = new Vector( 5, 5 );
    gethome = false;
  }
    
    
  protected void finalize()
  {
    super.finalize();
    waytonextfield = null;
  }
  
  protected void reason()
  {
    boolean search, helpback;
    search = false; 
    helpback = false;

    AdvancedSearchBAgentFieldList field;

    if( gohome == true && gethome == false )
    {
      gohome = false;
      if( log == true )
      {
        System.out.println( "Master: resetting gohome to: " + gohome );
        System.out.println( "I rather search for a new field to visit than going home" );
      }
    }
    
    // check waytonextfield vector for actions
    if( waytonextfield.isEmpty() == false )
    {
      if( log == true )
      {
        for( int i = waytonextfield.size() - 1; i >= 0; i-- )
        {
          System.out.println( "waytonextfield " + i + " is: " + ( ( Action ) waytonextfield.elementAt( i ) ).getName() );
        }
      }
      actions.addElement( waytonextfield.lastElement() );
      waytonextfield.removeElementAt( waytonextfield.size() - 1 );
      return;
    }

    super.reason(); 
    
    // now check if the returned action is a move to a field
    // already visited; if yes search for a field not yet
    // visited, otherwise accept the action.
    if( actions.isEmpty() == false && gethome == false )
    {
      gohome = false;
      String help = ( ( Action ) actions.firstElement() ).getName();
    
      // if a gold was on the first field we do not want to climb
      if( help.equals( "Climb" ) == true && moves == 2 )
      {
        search = searchNextVisit( location.getPlace() );
        if( search == true )
        {
          actions.removeAllElements();
          actions.addElement( waytonextfield.lastElement() );
          waytonextfield.removeElementAt( waytonextfield.size() - 1 );
        }
        else if( pickedgold == true )
        {
          updateWayBack();
          gethome = true;
          gohome = true;
          printField();
        }
      }

      if( help.equals( "Right" ) == true )
      {
        field = ( AdvancedSearchBAgentFieldList ) getRightField();
        if( field.wasVisited().equals( "YES" ) )
        {
          search = searchNextVisit( location.getPlace() );
          if( search == true )
          {
            actions.removeAllElements();
            actions.addElement( waytonextfield.lastElement() );
            waytonextfield.removeElementAt( waytonextfield.size() - 1 );
          }
          else if( pickedgold == true )
          {
            updateWayBack();
            gethome = true;
            gohome = true;
            printField();
          }
        }
      }
      if( help.equals( "Left" ) == true )
      {
        field = ( AdvancedSearchBAgentFieldList ) getLeftField();
        if( field.wasVisited().equals( "YES" ) )
        {
          search = searchNextVisit( location.getPlace() );
          if( search == true )
          {
            actions.removeAllElements();
            actions.addElement( waytonextfield.lastElement() );
            waytonextfield.removeElementAt( waytonextfield.size() - 1 );
          }
          else if( pickedgold == true )
          {
            updateWayBack();
            gethome = true;
            gohome = true;
            printField();
          }
        }
      }
      if( help.equals( "Up" ) == true )
      {
        field = ( AdvancedSearchBAgentFieldList ) getUpField();
        if( field.wasVisited().equals( "YES" ) )
        {
          search = searchNextVisit( location.getPlace() );
          if( search == true )
          {
            actions.removeAllElements();
            actions.addElement( waytonextfield.lastElement() );
            waytonextfield.removeElementAt( waytonextfield.size() - 1 );
          }
          else if( pickedgold == true )
          {
            updateWayBack();
            gethome = true;
            gohome = true;
            printField();
          }
        }
      }
      if( help.equals( "Down" ) == true )
      {
        field = ( AdvancedSearchBAgentFieldList ) getDownField();
        if( field.wasVisited().equals( "YES" ) )
        {
          search = searchNextVisit( location.getPlace() );
          if( search == true )
          {
            actions.removeAllElements();
            actions.addElement( waytonextfield.lastElement() );
            waytonextfield.removeElementAt( waytonextfield.size() - 1 );
          }
          else if( pickedgold == true )
          {
            updateWayBack();
            gethome = true;
            gohome = true;
            if( log == true )
            {
              printField();
            }
          }
        }
      }
    }
  }

  protected boolean searchNextVisit( Point recent )
  {
    Vector help;
    Point found;
    AdvancedSearchBAgentFieldList field;
    boolean success;
    success = false;
    help = new Vector( 5, 5 );
    searchqueue = new Vector( 5, 5 );
    
    for( int i = 0; i < cavesize.width; i++ )
    {
      for( int j = 0; j < cavesize.height; j++ )
      {
        if( ( field = ( AdvancedSearchBAgentFieldList ) myfield.getElement( i , j ) ) != null )
        {
          field.setSearched( false );
          field.setParent( new Point( -1, -1 ) );
        }
      }
    }

    found = searchBreadthNext( recent );
    if( found.x >= 0 && found.y >= 0 )
    {
      help = generateWay( found, recent );
      for( int i = 0; i < help.size(); i++ )
      {
        if( log == true )
        {
          System.out.println( " waytonextfield: adding elements " );
        }
        waytonextfield.addElement( help.elementAt( help.size() - i - 1 ) );
      }
      success = true;
    }
    
    searchqueue.removeAllElements();

    for( int i = 0; i < cavesize.width; i++ )
    {
      for( int j = 0; j < cavesize.height; j++ )
      {
        if( ( field = ( AdvancedSearchBAgentFieldList ) myfield.getElement( i , j ) ) != null )
        {
          field.setSearched( false );
          field.setParent( new Point( -1, -1 ) );
        }
      }
    }

    if( log == true )
    {
      System.out.println(" returning success: " + success );
    }
    return success;
  }

  protected Point searchBreadthNext( Point recent )
  {
    Point workpoint, failed;
    AdvancedSearchBAgentFieldList help, up, down, left, right, next, field;
    Point cup, cdown, cleft, cright;
    boolean found;
     
    found = false;
    failed = new Point( -1, -1 );

    help = ( AdvancedSearchBAgentFieldList ) myfield.getElement( recent.x, recent.y );
    if( log == true )
    {
      System.out.println( "Starting search at: " + recent.x + "/" + recent.y );
    }

    // put starting point in Vector - ' queue '
    // and mark  it as worked
    help.setSearched( true );
    searchqueue.addElement( ( Object ) help );

    do
    {
      // get first Element and remove it from queue
      recent = ( ( AdvancedSearchBAgentFieldList ) searchqueue.firstElement() ).getPlace();    
      field = ( AdvancedSearchBAgentFieldList ) myfield.getElement( recent.x, recent.y );
      searchqueue.removeElementAt( 0 );
      if( log == true )
      {
        System.out.println( "Got Point from queue: " + recent.x + "/" + recent.y );
        System.out.println( "Checking for goal - field" );
      }
      
      if( field.wasVisited().equals( "NO" ) && field.hasWumpus().equals( "NO" ) &&
          field.hasPit().equals( "NO" )  && field.isWall().equals( "NO" ) )
      {
        if( log == true )
        {
          System.out.println( "Found TARGET field." );
        }
        found = true;
      }
      else
      {
        if( log == true )
        {
          System.out.println( "Field is of no interest." );
        }
      }
      
      // get neighbour coordinates if no goal field has been found yet
      // also check if this is a save field; only then add its neighbours to the queue
      if( found == false && field.hasWumpus().equals( "NO" )  &&  field.hasPit().equals( "NO" )  &&
          field.isWall().equals( "NO" ) )
          
      {
        cup    = new Point( recent.x, recent.y - 1 );
        cdown  = new Point( recent.x, recent.y + 1 );
        cleft  = new Point( recent.x - 1, recent.y );
        cright = new Point( recent.x + 1, recent.y );
        
        if( ( cleft.x >= 0 && cleft.y >= 0 ) && ( cleft.x < cavesize.width && cleft.y < cavesize.height ) )
        {  
          left  = ( AdvancedSearchBAgentFieldList ) myfield.getElement( recent.x - 1, recent.y );
          if( left.getSearched() == false )
          { 
            left.setParent( recent );
            left.setSearched( true );
            searchqueue.addElement( ( Object ) left );
          }
        }
        if( ( cdown.x >= 0 && cdown.y >= 0 ) && ( cdown.x < cavesize.width && cdown.y < cavesize.height ) )
        {
          down  = ( AdvancedSearchBAgentFieldList ) myfield.getElement( recent.x, recent.y + 1 );
          if( down.getSearched() == false )
          {
            down.setParent (recent ); 
            down.setSearched( true );
            searchqueue.addElement( ( Object ) down );
          }
        }
        if( ( cright.x >= 0 && cright.y >= 0 ) && ( cright.x < cavesize.width && cright.y < cavesize.height ) )
        {  
          right = ( AdvancedSearchBAgentFieldList ) myfield.getElement( recent.x + 1, recent.y );
          if( right.getSearched() == false )
          {
            right.setParent( recent );
            right.setSearched( true );
            searchqueue.addElement( ( Object ) right );
          }
        }
        if( ( cup.x >= 0 && cup.y >= 0 ) && ( cup.x < cavesize.width && cup.y < cavesize.height ) )
        {  
          up    = ( AdvancedSearchBAgentFieldList ) myfield.getElement( recent.x, recent.y - 1 );
          if( up.getSearched() == false )
          {
            up.setParent( recent );
            up.setSearched( true );
            searchqueue.addElement( ( Object ) up );
          }
        }
      }
    } while ( searchqueue.isEmpty() == false && found == false );

    if( found == true )
    {
      return recent;
    }
    else
    {
      return failed;
    }
  } 

  protected void printField()
  {
    AdvancedSearchBAgentFieldList field;
    for( int i = 0; i < cavesize.width; i++ )
    {
	  for( int j = 0; j < cavesize.height; j++ )
      {
        if( ( field = ( AdvancedSearchBAgentFieldList ) myfield.getElement( i, j ) ) != null )
        {
          System.out.println("Field[ " + i + " ] [ " + j + " ] ");
          System.out.println("IsExit: " + field.isExit() );
          System.out.println("HasWumpus: " + field.hasWumpus() );
          System.out.println("HasPit: " + field.hasPit() );
          System.out.println("IsWall: " + field.isWall() );
          System.out.println("WasVisited: " + field.wasVisited() );
        }
        else
        {
          System.out.println("Field " + i + "/" + j + " not allocated yet." );
        }
      }
    }
  }
}

