// file:        MxNActiveObject.java
// source file: MxNActiveObject.java
// object file: MxNActiveObject.class
//
//
// included objects:
//  MxNActiveObject
//    Desc: implements an active object for use in mxn environments
//
//
// history:
//   22.02.97 - first version finished by Chris
//
//   13.03.97 - development off. continued by Roman:
//              added ducumentation,
//              new extensions for displaying images (as per protocol 11.03.97) - Roman
//   22.03.97 - revised documentation - Roman
//
//
// critical problems: none
//
// known problems: none
//
 
import java.awt.*;
import java.awt.image.ImageObserver;
import java.util.*;
import java.lang.*;

abstract class MxNActiveObject extends ActiveObject
{

// Method: MxNActiveObject Constructor (public)
//
// *Purpose   : intializes a new instance and sets a new image(-resource)
//              for the object
//
// *Parameters: name (String) - name of the new instance
//              type (String) - general type of the new instance
//              resource (String) - name of the resource for the FieldObject
//              observer (ImageObserver) - observer for the FieldObject
//
// *Return    : none
//
// *Variables : only through super
//
  public MxNActiveObject( String name, String type, String resource,
    ImageObserver observer )
  {
    super( name, type, resource, observer );
  }

  public MxNActiveObject( String name, String type, String resource )
  {
    super( name, type, resource, null );
  }

  public MxNActiveObject( String name, String type, ImageObserver observer )
  {
    super( name, type, null, observer );
  }

  public MxNActiveObject( String name, String type )
  {
    super( name, type, null, null );
  }

}//End of class MxNActiveObject
