// file:        PassiveObject.java
// source file: PassiveObject.java
// object file: PassiveObject.class
//
//
// included objects:
//  PassiveObject
//    Desc: implements a passive object (none-acting) for standard 
//          environments (with no specific dimension)
//
//
// history:
//   22.02.97 - first version finished by Chris
//
//   13.03.97 - development off. continued by Roman:
//              new extensions for displaying images (as per protocol 11.03.97) - Roman
//   22.03.97 - added & revised documentation - Roman
//   11.04.97 - changed Constructors back to old design - property methods
//              set/getRes and set/getImageObserver will handle optional
//              paramethers now
//
//
// critical problems: none
//
// known problems: none
//
 
import java.awt.*;
import java.awt.image.ImageObserver;
import java.util.*;
import java.lang.*;

abstract class PassiveObject extends FieldObject
{
 
// Method: PassiveObject Constructor (public)
//
// *Purpose   : intializes a new instance and sets a new image(-resource)
//              for the object
//
// *Parameters: name (String) - name of the new instance
//              type (String) - general type of the new instance
//              resource (String) - name of the resource for the FieldObject
//              observer (ImageObserver) - observer for the FieldObject
//
// *Return    : none
//
// *Variables : super
//
  public PassiveObject( String name, String type, String resource,
    ImageObserver observer )
  {
    super( name, type, resource, observer );
  }

  public PassiveObject( String name, String type, String resource )
  {
    super( name, type, resource, null );
  }

  public PassiveObject( String name, String type, ImageObserver observer )
  {
    super( name, type, null, observer );
  }

  public PassiveObject( String name, String type )
  {
    super( name, type, null, null );
  }
  
}//End of PassiveObject
