// file:        PerceptConstants.java
// source file: PerceptConstants.java
// object file: PerceptConstants.class
//
//
// included objects:
//  ActionConstants
//    Desc: includes all percept constants necessary in the project 
//          and two conversion methods (percept_string <-> value)
//
// history:
//   01.04.97 - first version finished by Roman Valehrach
//
// critical problems: none
//
// known problems: none
//


import java.lang.Integer;

class PerceptConstants extends Object {

// --- Percepts - String constansts: --------------------------------------
  static final String STR_BUMP    = "BUMP";

  static final String STR_GLITTER = "GLITTER";
  static final String STR_STENCH  = "STENCH";
  static final String STR_SCREAM  = "SCREAM";
  static final String STR_BREEZE  = "BREEZE";

  static final String STR_DIRT    = "DIRT";
  static final String STR_HOME    = "HOME";


// --- Percepts - binary coded constansts: --------------------------------
  static final int BASE    = 0x40;

  static final int BUMP    = 0x00 | BASE;
  static final int GLITTER = 0x01 | BASE;
  static final int STENCH  = 0x02 | BASE;
  static final int SCREAM  = 0x04 | BASE;
  static final int BREEZE  = 0x08 | BASE;

  static final int BASE2   = 0x80;
  static final int DIRT    = 0x00 | BASE2;
  static final int HOME    = 0x01 | BASE2;

  static final int BASE3   = 0x100;

// public methods:

  public String percept2String(int percept)
  {
    switch(percept) {
      case BUMP:     return STR_BUMP;
      case GLITTER:  return STR_GLITTER;
      case STENCH:   return STR_STENCH;
      case SCREAM:   return STR_SCREAM;
      case BREEZE:   return STR_BREEZE;

      case DIRT:     return STR_DIRT;
      case HOME:     return STR_HOME;
      default:       return (null);
    }
  }


  public int String2percept(String percept)
  {
    if (percept.equalsIgnoreCase(STR_BUMP))     return BUMP;
    if (percept.equalsIgnoreCase(STR_GLITTER))  return GLITTER;
    if (percept.equalsIgnoreCase(STR_STENCH))   return STENCH;
    if (percept.equalsIgnoreCase(STR_SCREAM))   return SCREAM;
    if (percept.equalsIgnoreCase(STR_BREEZE))   return BREEZE;

    if (percept.equalsIgnoreCase(STR_DIRT))     return DIRT;
    if (percept.equalsIgnoreCase(STR_HOME))     return HOME;
    return(0);
  }

} // End of Class PerceptConstants
