// file:        Resources.java
// source file: Resources.java
// object file: Resources.class
//
//
// included objects:
//  Resources
//    Desc: implements an reference to mulitple images references (easily
//          extended structur)
//
//
// history:
//   07.03.97 - creation of class - Roman Valehrach
//
//   22.03.97 - added & revised documentation - Roman
//   12.04.97 - added methods for image/reference/checking
//
//
// critical problems: none
//
// known problems: none
//

import java.util.Vector;
import java.awt.Image;
import java.awt.image.ImageObserver;


class Resources extends Object
{
  public Vector images;


// Method: Resources Constructor (public)
//
// *Purpose   : intializes a new instance and creates a new reference
//              vector
//
// *Parameters: none
//
// *Return    : none
//
// *Variables : images (Vector, class) - stores the references to image 
//                                       resources
//
  Resources() 
  {
    this.images = new Vector();
  }

  public Vector getImages() 
  {
    return this.images;
  }

  protected void setImages( Vector images ) 
  {
    if (images != null)
    {
      // System.out.println("Resources: setting the images via clone...");
//      this.images = images;
      this.images = (Vector)images.clone();
    }
  }


  public static int getImageReferencesSize( Resources ref )
  {
    if ( (ref instanceof Resources) &&
         (ref.images != null) )
      return ref.images.size();
    else
      return 0;
  }

  public int getImageReferencesSize()
  {
    if (this.images != null)
      return this.images.size();
    else
      return 0;
  }

  public static boolean ImageReferencesIsEmpty( Resources ref )
  {
    if ( (ref instanceof Resources) && (ref.images != null) )
      return ref.images.isEmpty();
    else
      return true;
  }

  public boolean ImageReferencesIsEmpty()
  {
    if (this.images != null)
      return this.images.isEmpty();
    else
      return true;
  }

// Method: add[checked]ImageReference (public, static)
//
// *Purpose   : appends an ImageReference to the Resources
//
// *Parameters: ref (Resources) - the Resources to add to
//              
//
// *Return    : boolean - successfully added or not
//
// *Variables : none
//
  public static boolean addImageReference( Resources ref,
                                           ImageReference img_ref )
  {
    if ( ref instanceof Resources )
    {
      if ( ref.images == null )
        ref.images = new Vector();

      ref.images.addElement( (Object) img_ref);
      return true;
    }
    return false;
  }

  public boolean addImageReference( ImageReference img_ref )
  {
    return addImageReference( this, img_ref );
  }

  public static boolean addCheckedImageReference( Resources ref,
                                                  ImageReference img_ref )
  {
    if ( ( ref instanceof Resources ) && 
         ( ImageReference.checkImageReference( img_ref ) == true ) )
    {
      if ( ref.images == null )
        ref.images = new Vector();

      ref.images.addElement( (Object) img_ref);
      return true;
    }
    return false;
  }

  public boolean addCheckedImageReference( ImageReference img_ref )
  {
     return addCheckedImageReference( this, img_ref );
  }


// Method: removeImageReference (public, static)
//
// *Purpose   : removes an ImageReference from the Resources
//
// *Parameters: ref (Resources) - the Resources to add to
//              
//
// *Return    : boolean - successfully added or not
//
// *Variables : none
//
  public static boolean removeImageReference( Resources ref,
                                              ImageReference img_ref )
  {
    if ( (img_ref instanceof ImageReference) && 
         (ref instanceof Resources) && 
         (ref.images != null ) )
    {
      return ref.images.removeElement( (Object) img_ref);
    }
    return false;
  }

  public boolean removeImageReference( ImageReference img_ref )
  {
    if ( images != null )
    {
      return images.removeElement( (Object) img_ref);
    }
    return false;
  }


// Method: removeAllImageReferences (public, static)
//
// *Purpose   : removes an ImageReference from the Resources
//
// *Parameters: ref (Resources) - the Resources to add to
//              
//
// *Return    : boolean - successfully added or not
//
// *Variables : none
//
  public static void removeAllImageReferences( Resources ref )
  {
    if ( ref.images != null )
    {
      ref.images.removeAllElements();
    }
  }

  public void removeAllImageReferences()
  {
    if ( images != null )
    {
      images.removeAllElements();
    }
  }


// Method: getImageReferenceAt (public, static)
//
// *Purpose   : returns the image-reference at position num
//
// *Parameters: num (int) - the position of the image to check...
//         or : curr_ref (Resources) - the reference to test
//         or : curr_image (Image)        or the image to test
//
// *Return    : ImageReference - the element at positon num
//
// *Variables : none
//
  public static ImageReference getImageReferenceAt( Resources curr_ref, 
                                                    int num )
  {
    if ( ( curr_ref != null ) && ( curr_ref.images != null ) &&
         ( curr_ref.images.size() > num ) )
      return ((ImageReference) (curr_ref.images.elementAt( num )));
    else
      return null;
  }

  public ImageReference getImageReferenceAt( int num )
  {
    return getImageReferenceAt( this, num );
  }


// Method: getCheckedImageReferenceAt (public, static)
//
// *Purpose   : returns only valid image-reference at position num
//
// *Parameters: num (int) - the position of the image to check...
//         or : curr_ref (Resources) - the reference to test
//         or : curr_image (Image)        or the image to test
//
// *Return    : ImageReference - the element at positon num
//
// *Variables : none
//
  public static ImageReference 
    getCheckedImageReferenceAt( Resources curr_ref, int num )
  {
    ImageReference tmp_ref= null;

    if ( ( curr_ref != null ) && ( curr_ref.images != null ) &&
         ( curr_ref.images.size() > num ) ) 
    {
      tmp_ref = ((ImageReference)(curr_ref.images.elementAt( num )));
      return ImageReference.doImageReferenceCheck( tmp_ref );
    }
    else
      return null;
  }

  public ImageReference getCheckedImageReferenceAt( int num )
  {
    return getCheckedImageReferenceAt( this, num );
  }


// Method: getImageAt (public, static)
//
// *Purpose   : returns the image at position num
//
// *Parameters: num (int) - the position of the image to check...
//         or : curr_ref (Resources) - the reference to test
//         or : curr_image (Image)        or the image to test
//
// *Return    : Image - the element at positon num
//
// *Variables : none
//
  public static Image getImageAt( Resources curr_ref, int num )
  {
    if ( ( curr_ref != null ) && ( curr_ref.images != null ) &&
         ( curr_ref.images.size() > num ) )
      return ((ImageReference)(curr_ref.images.elementAt( num ))).getImage();
    else
      return null;
  }

  public Image getImageAt( int num )
  {
    return getImageAt( this, num );
  }


// Method: getCheckedImageAt (public, static)
//
// *Purpose   : returns only valid images at position num
//
// *Parameters: num (int) - the position of the image to check...
//         or : curr_ref (Resources) - the reference to test
//         or : curr_image (Image)        or the image to test
//
// *Return    : Image - the element at positon num
//
// *Variables : none
//
  public static Image getCheckedImageAt( Resources curr_ref, int num  )
  {
    ImageReference tmp_ref= null;

    if ( ( curr_ref != null ) && ( curr_ref.images != null ) &&
         ( curr_ref.images.size() > num ) ) 
    {
      tmp_ref = ((ImageReference)(curr_ref.images.elementAt( num )));
      return ImageReference.doImageCheck( tmp_ref );
    }
    else
      return null;
  }

  public Image getCheckedImageAt( int num )
  {
    return getCheckedImageAt( this, num );
  }


// Method: checkImageAt (public, static)
//
// *Purpose   : checks wheter the current reference/image is valid and
//              returns the result
//
// *Parameters: num (int) - the position of the image to check...
//         or : curr_ref (Resources) - the reference to test
//         or : curr_image (Image)        or the image to test
//
// *Return    : boolean - the result of the check
//         or :
//
// *Variables : none
//
  public static boolean checkImageAt( Resources curr_ref, int num )
  {
    if ( ( curr_ref != null ) && ( curr_ref.images != null ) &&
         ( curr_ref.images.size() > num ) )
      return ((ImageReference)(curr_ref.images.elementAt( num ))).checkImage();
    else
      return false;
  }

  public boolean checkImageAt( int num )
  {
    return checkImageAt( this, num );
  }


// Method: doImageCheckAt (public, static)
//
// *Purpose   : checks wheter the current reference/image is valid and
//              returns the image or null depending on the result
//
// *Parameters: num (int) - the position of the image to check...
//         or : curr_ref (ImageReference) - the reference to test
//
// *Return    : Image - the checked Image
//
// *Variables : none
//
  public static Image doImageCheckAt( Resources curr_ref, int num )
  {
    if ( ( curr_ref instanceof Resources ) && 
         ( curr_ref.images != null ) &&
         ( curr_ref.images.size() > num ) )
    {
      ImageReference tmp= (ImageReference) (curr_ref.images.elementAt( num ));
      if (tmp instanceof ImageReference)
        return tmp.doImageCheck();
    }
    return null;
  }

  public Image doImageCheckAt( int num )
  {
    return doImageCheckAt( this, num );
  }

// Method: finalize (public)
//
// *Purpose   : removes all device-depenting resources,
//              just a small JAVA-specifi garbage routine
//         
// *Parameters: none
//
// *Return    : none
//
// *Variables : none
//
  public void finalize() throws Throwable
  {
//    images.finalize();
    super.finalize();

  }// End of finalize
}// End of class Resources
