
// Class WumpusEnvironment
// Author: ALOBA Babatope
//         Technical University of Vienna
//
// Creation Date: Nov 1996
//
// last modified: December through February 1997
//      *main coding Phase
//
// last modified: 21 March 1997
// known bugs: none
// last modified: 25 March 1997
//      * Agents should not be displayed after they are eaten by Wumpus
//      * Agents should not be displayed after they climb out of the exit
//      * Every move costs agent -1 point (only moves, no grabs/shots included)
//      *
// last modified: 31 March 1997
//      * When an agent falls down a pit or is eaten up by a wumpus,
//        it should  remain on the field
//
// last modified: 17 April 1997
//      * acknowledged and incorporated roman's suggestions
//        pertaining to finalize();
//      * attempting to incorporate some more visible means of
//          seeing what the agent does, for example by animating an arrow
//      * Succeeded. An arrow now flies through the air when an agent shoots
//
// last modified: 25 April 1997
//      * minor enhancements.


import Constants;
import java.awt.*;
import java.awt.image.*;
import java.util.Vector;
import java.util.Enumeration;
import java.lang.Integer;
import java.lang.Math;
import java.net.*;


public class WumpusEnvironment extends MxNEnvironment {
  // if debug=true -> debugging info is displayed.
  static boolean debug = false;
  WumpusField[][] field; // Overrides overclass definition
  Rectangle grect;
  Dimension envsize;
  Vector activeagents = new Vector(Constants.MAXAGENTS);
  Vector inactiveagents = new Vector(Constants.MAXAGENTS);
  FieldObject[] fldobjlist;
  //Vector allfldobj = new Vector();
  Toolkit toolkit;
  Image image;
  Vector imageres = new Vector();
  String url;
  ResourceLoader resloader;
  Point[][] fieldcoords; //to store each field's center coordinates
  Image arrow = null;
  Image arrowup;
  Image arrowdown;
  Image arrowleft;
  Image arrowright;
  int arrowlength;
  int slc = 0; //status line counter
  Canvas canvas = new Canvas();
  MediaTracker tracker = new MediaTracker(canvas);
  int image_id = 1; //integer identifier for images


   // Contructor:
   // parses the string array envparam and creates the necessary 
   // Fields and FieldObjects by going through envparam[y][x]
   // This is the main parse routine. envparam is an 
   // Array of Arrays i.e. a 2 Dimensional Array and
   // this routine checks the first element of each array
   // of arays and accordingly knows how the parameters 
   // are to be read in.

   public WumpusEnvironment(String wumpusenvname, String[][] wumpusenvparam, String newurl)
   {
	   super(wumpusenvname, wumpusenvparam);
           url = newurl;
           if(debug==true) System.out.println("Entering WumpusEnvironment Constructor");
           if(debug==true) System.out.println("url: " +url);

           toolkit = Toolkit.getDefaultToolkit();
           WumpusAgentReference war;
           resloader = new ResourceLoader();
           arrowup = resloader.getImage("images/a_us.gif");
           arrowdown = resloader.getImage("images/a_ds.gif");
           arrowleft = resloader.getImage("images/a_ls.gif");
           arrowright = resloader.getImage("images/a_rs.gif");

//           arrowup = resloader.getImage("images/newu.gif");
//           arrowdown = resloader.getImage("images/newd.gif");
//           arrowleft = resloader.getImage("images/newl.gif");
//           arrowright = resloader.getImage("images/newr.gif");

//           tracker.addImage(arrowup, image_id);
//           tracker.addImage(arrowdown, image_id);
//           tracker.addImage(arrowleft, image_id);
//           tracker.addImage(arrowright, image_id);
           

	   main_loop:
           for(int i=0; i < envparam.length; i++)
	   {
             if(debug==true) System.out.println("Entering Constructor mainloop");
             String oname; //object name
             int x; //coordinate
             int y; //coordinate
             int l; //length
	     FieldObject fo;
             String p = envparam[i][0];
             if(debug==true) System.out.println("read in envparam p:->" +p +"<-");
             if(debug==true) System.out.println("Entering Constructor switch loop...");
             if(debug==true) System.out.println("p= " +Integer.parseInt(p));

             switch(Integer.parseInt(p))
             {
		// this signals the beginning of the parameter Data
                // and all the following data up to: 
                // envsize.width * envsize.height
                case Constants.FIELDS:
		envsize = new Dimension(Integer.parseInt(envparam[i][1]), Integer.parseInt(envparam[i][2]));
                if(debug==true) System.out.println("envsize w: " +envsize.width +"h: " +envsize.height);
		field = new WumpusField[envsize.width][envsize.height];
		int counter = 3; //0,1,2 are params
	       	for (y=0; y<envsize.height; y++)
	   	{
			for (x=0; x<envsize.width; x++)
			{
                           p = envparam[i][counter];
                           if(debug==true) System.out.println("parameter p: " +p);
                           if(debug==true) System.out.println("creating field " +x +"," +y +"with p");
                           switch (Integer.parseInt(p))
			   {
				case Constants.EXIT:
                               		field[x][y] = new WumpusField("EXIT");
				  	counter += 1;
				break;

				case Constants.WALL:
				  field[x][y] = new WumpusField("WALL");
				  counter += 1;
				break;

				case Constants.PIT:
				  field[x][y]  = new WumpusField("PIT");
				  counter += 1;
				break;

				default:
                                 if(debug==true) System.out.println("parameter: " +p +" not recognised !");
                                break;

				case Constants.SPACE:
				  field[x][y] = new WumpusField("SPACE");
				  counter += 1;
				break;
			   } // End switch (Integer.parseInt(envparam[y+i][x]))
//	                   if (!field[x][y].resname.equals("EMPTY")) {
//          	        	field[x][y].giveImage(retrieveImage(field[x][y].resname));
//                	   }
			} // End for (int x...
                } // End for (int y...
		break;	

		case Constants.GOLD:
			l = envparam[i].length;
        	        oname = envparam[i][1];
			x = Integer.parseInt(envparam[i][2]);
			y = Integer.parseInt(envparam[i][3]);
			if (l<5) {
				fo = new Gold(oname);
			 }
	                else {
				fo = new Gold(oname, envparam[i][4]);
			}
//	                if (!fo.resname.equals("EMPTY")) {
//	                  fo.giveImage(retrieveImage(fo.resname));
//	                }
			field[x][y].addObject(fo);
		break;

		case Constants.WUMPUS:
			l = envparam[i].length;
	                oname = envparam[i][1];
			x = Integer.parseInt(envparam[i][2]);
			y = Integer.parseInt(envparam[i][3]);
			if (l<5) {
	                	fo = new Wumpus(oname, x, y);
			}
			else {
		                fo = new Wumpus(oname, x, y, envparam[i][4]);
			}
//	                if (!fo.resname.equals("EMPTY")) {
//	                  fo.giveImage(retrieveImage(fo.resname));
//	                }
			field[x][y].addObject(fo);
                        if(debug==true) System.out.println("added wumpus to field" +x+", "+y);
		break;

                case Constants.AGENT:
                // Any and all kinds of agents are created here.
                //To add a different kind of agent, simply copy a
                // ->if (agenttype.equalsIgno...<-
                // code block and modify it to the new agent's name.
                     war = null;
                     l = envparam[i].length;
                     String agenttype = envparam[i][1];
                     oname = envparam[i][2];
                     x = Integer.parseInt(envparam[i][3]); // no of arrows
                     String resname = null;
                     if(l>4) resname = envparam[i][4];
                        if(debug==true) System.out.println("no of params="+l);
 			if(debug==true) System.out.println("agenttype: "+agenttype);
 			if(debug==true) System.out.println("name: "+oname);
 			if(debug==true) System.out.println("arrows: "+x);

                     //------------------------------------------------------
                     //TESTAGENT
                     if (agenttype.equalsIgnoreCase("TestAgent")) {
                        if (l<5) {
                          war = new WumpusAgentReference(new TestAgent(oname, x, envsize));
	                }
	                else {
                          war = new WumpusAgentReference(new TestAgent(oname, x, envsize, resname));
	                }
                     } //End if (agenttype.equalsIgnoreCase("TestAgent"))

                     //------------------------------------------------------
                     //DUMBWUMPUS
                     if (agenttype.equalsIgnoreCase("DumbWumpus")) {
                        if (l<5) {
                          war = new WumpusAgentReference(new DumbWumpus(oname, x, envsize));
	                }
	                else {
                          war = new WumpusAgentReference(new DumbWumpus(oname, x, envsize, resname));
	                }
                     } //End if (agenttype.equalsIgnoreCase("DumbWumpus"))

                     //------------------------------------------------------
                     //ARRAYBACKWUMPUS
                     if (agenttype.equalsIgnoreCase("ArrayBackWumpus")) {
                        if (l<5) {
                          war = new WumpusAgentReference(new ArrayBackWumpus(oname, x, envsize));
	                }
	                else {
                          war = new WumpusAgentReference(new ArrayBackWumpus(oname, x, envsize, resname));
	                }
                     } //End if (agenttype.equalsIgnoreCase("ArrayBackWumpus"))

                     //------------------------------------------------------
                     //ARRAYBREATHWUMPUS
                     if (agenttype.equalsIgnoreCase("ArrayBreathWumpus")) {
                        if (l<5) {
                          war = new WumpusAgentReference(new ArrayBreathWumpus(oname, x, envsize));
	                }
	                else {
                          war = new WumpusAgentReference(new ArrayBreathWumpus(oname, x, envsize, resname));
	                }
                     } //End if (agenttype.equalsIgnoreCase("ArrayBreathWumpus"))

                     //------------------------------------------------------
                     //REFLEXWUMPUS
                     if (agenttype.equalsIgnoreCase("ReflexWumpus")) {
                        if (l<5) {
                          war = new WumpusAgentReference(new ReflexWumpus(oname, x, envsize));
                        }
                        else {
                          war = new WumpusAgentReference(new ReflexWumpus(oname, x, envsize, resname));
                        }
                     } //End if (agenttype.equalsIgnoreCase("ReflexWumpus"))
 
                     //------------------------------------------------------
                     //REFLEXWUMPUS2
                     if (agenttype.equalsIgnoreCase("ReflexWumpus2")) {
                        if (l<5) {
                          war = new WumpusAgentReference(new ReflexWumpus2(oname, x, envsize));
                        }
                        else {
                          war = new WumpusAgentReference(new ReflexWumpus2(oname, x, envsize, resname));
                        }
                     } //End if (agenttype.equalsIgnoreCase("ReflexWumpus2"))

                     //------------------------------------------------------
                     //REFLEXWUMPUS3
                     if (agenttype.equalsIgnoreCase("ReflexWumpus3")) {
                        if (l<5) {
                          war = new WumpusAgentReference(new ReflexWumpus3(oname, x, envsize));
                        }
                        else {
                          war = new WumpusAgentReference(new ReflexWumpus3(oname, x, envsize, resname));
                        }
                     } //End if (agenttype.equalsIgnoreCase("ReflexWumpus3"))

                     //------------------------------------------------------
                     //ARRAYDEPTHWUMPUS
                     if (agenttype.equalsIgnoreCase("ArrayDepthWumpus")) {
                        if (l<5) {
                          war = new WumpusAgentReference(new ArrayDepthWumpus(oname, x, envsize));
	                }
	                else {
                          war = new WumpusAgentReference(new ArrayDepthWumpus(oname, x, envsize, resname));
	                }
                     } //End if (agenttype.equalsIgnoreCase("ArrayDepthWumpus"))
 
                     //------------------------------------------------------
                     //ARRAYDEPTHLIMITEDWUMPUS
                     if (agenttype.equalsIgnoreCase("ArrayDepthLimitedWumpus")) {
                        if (l<5) {
                          war = new WumpusAgentReference(new ArrayDepthLimitedWumpus(oname, x, envsize));
	                }
	                else {
                          war = new WumpusAgentReference(new ArrayDepthLimitedWumpus(oname, x, envsize, resname));
	                }
                     } //End if (agenttype.equalsIgnoreCase("ArrayDepthLimitedWumpus"))
 
                     //------------------------------------------------------
                     //ARRAYWDEPTHITERATEDUMPUS
                     if (agenttype.equalsIgnoreCase("ArrayDepthIteratedWumpus")) {
                        if (l<5) {
                          war = new WumpusAgentReference(new ArrayDepthIteratedWumpus(oname, x, envsize));
	                }
	                else {
                          war = new WumpusAgentReference(new ArrayDepthIteratedWumpus(oname, x, envsize, resname));
	                }
                     } //End if (agenttype.equalsIgnoreCase("ArrayDepthIteratedWumpus"))
 
                     //------------------------------------------------------
                     //ARRAYWUMPUS
                     if (agenttype.equalsIgnoreCase("ArrayWumpus")) {
                        if (l<5) {
                          war = new WumpusAgentReference(new ArrayWumpus(oname, x, envsize));
	                }
	                else {
                          war = new WumpusAgentReference(new ArrayWumpus(oname, x, envsize, resname));
	                }
                     } //End if (agenttype.equalsIgnoreCase("ArrayWumpus"))

                     //------------------------------------------------------
                     //HASHWUMPUS
                     if (agenttype.equalsIgnoreCase("HashWumpus")) {
                        if (l<5) {
                          war = new WumpusAgentReference(new HashWumpus(oname, x, envsize));
	                }
	                else {
                          war = new WumpusAgentReference(new HashWumpus(oname, x, envsize, resname));
	                }
                     } //End if (agenttype.equalsIgnoreCase("HashWumpus"))

 //------------------------------------------------------
                     //ARRAYMASTERWUMPUS
                     if (agenttype.equalsIgnoreCase("ArrayMasterWumpus")) {
                        if (l<5) {
                          war = new WumpusAgentReference(new ArrayMasterWumpus(oname, x, envsize));
	                }
	                else {
                          war = new WumpusAgentReference(new ArrayMasterWumpus(oname, x, envsize, resname));
	                }
                     } //End if (agenttype.equalsIgnoreCase("ArrayBreathWumpus"))

                    //HASHBACKWUMPUS
                     if (agenttype.equalsIgnoreCase("HashBackWumpus")) {
                        if (l<5) {
                          war = new WumpusAgentReference(new HashBackWumpus(oname, x, envsize));
	                }
	                else {
                          war = new WumpusAgentReference(new HashBackWumpus(oname, x, envsize, resname));
	                }
                     } //End if (agenttype.equalsIgnoreCase("HashBackWumpus"))

                     //HASHDEPTHWUMPUS
                     if (agenttype.equalsIgnoreCase("HashDepthWumpus")) {
                        if (l<5) {
                          war = new WumpusAgentReference(new HashDepthWumpus(oname, x, envsize));
	                }
	                else {
                          war = new WumpusAgentReference(new HashDepthWumpus(oname, x, envsize, resname));
	                }
                     } //End if (agenttype.equalsIgnoreCase("HashDepthWumpus"))

                     //HASHDEPTHITERATEDWUMPUS
                     if (agenttype.equalsIgnoreCase("HashDepthIteratedWumpus")) {
                        if (l<5) {
                          war = new WumpusAgentReference(new HashDepthIteratedWumpus(oname, x, envsize));
	                }
	                else {
                          war = new WumpusAgentReference(new HashDepthIteratedWumpus(oname, x, envsize, resname));
	                }
                     } //End if (agenttype.equalsIgnoreCase("HashDepthIteratedWumpus"))

                     //HASHDEPTHLIMITEDWUMPUS
                     if (agenttype.equalsIgnoreCase("HashDepthLimitedWumpus")) {
                        if (l<5) {
                          war = new WumpusAgentReference(new HashDepthLimitedWumpus(oname, x, envsize));
	                }
	                else {
                          war = new WumpusAgentReference(new HashDepthLimitedWumpus(oname, x, envsize, resname));
	                }
                     } //End if (agenttype.equalsIgnoreCase("HashDepthLimitedWumpus"))

                     //HASHBREADTHWUMPUS
                     if (agenttype.equalsIgnoreCase("HashBreadthWumpus")) {
                        if (l<5) {
                          war = new WumpusAgentReference(new HashBreadthWumpus(oname, x, envsize));
	                }
	                else {
                          war = new WumpusAgentReference(new HashBreadthWumpus(oname, x, envsize, resname));
	                }
                     } //End if (agenttype.equalsIgnoreCase("HashBreadthWumpus"))

                     //HASHMASTERWUMPUS
                     if (agenttype.equalsIgnoreCase("HashMasterWumpus")) {
                        if (l<5) {
                          war = new WumpusAgentReference(new HashMasterWumpus(oname, x, envsize));
	                }
	                else {
                          war = new WumpusAgentReference(new HashMasterWumpus(oname, x, envsize, resname));
	                }
                     } //End if (agenttype.equalsIgnoreCase("HashMasterWumpus"))


                     //-----------Agent Initialization------------------------
                     // now initialize the succesfully created agent
                     if (war instanceof WumpusAgentReference)
                     {
//                      if (!war.myactiveobject.resname.equals("EMPTY")) {
//                        war.myactiveobject.giveImage(retrieveImage(war.myactiveobject.resname));
//	                }
//                       ((WumpusAgent)(war.myactiveobject)).giveActionImages((Resources)actionimages);
                        field[1][1].addObject((FieldObject)war.myactiveobject);
                        // Assign a status line to the agent
                        slc++;
                        war.slc = slc;
                        activeagents.addElement(war);
                        if(debug==true) System.out.println("Added " +war.myactiveobject.getName() +" to activeagents");
                     }
                     else
                     {
                        if(debug==true) System.out.println("Could not add agent: "+agenttype);
                     }
                break;

                /* /--------------
                case Constants.ARRAYWUMPUS:
	                l = envparam[i].length;
	                oname = envparam[i][1];
        	        x = Integer.parseInt(envparam[i][2]); // no of arrows
	                if (l<4) {
                          war = new WumpusAgentReference(new ArrayWumpus(oname, x, envsize));
	                }
	                else {
                          war = new WumpusAgentReference(new ArrayWumpus(oname, x, envsize, envparam[i][3]));
	                }
//                      if (!war.myactiveobject.resname.equals("EMPTY")) {
//                        war.myactiveobject.giveImage(retrieveImage(war.myactiveobject.resname));
//	                }
//                      ((WumpusAgent)(war.myactiveobject)).giveActionImages((Resources)actionimages);
                        if(debug==true) System.out.println("right b4 da problem line field.addObject");
                        field[1][1].addObject((FieldObject)war.myactiveobject);
                        if(debug==true) System.out.println("right after da problem line field.addObject");
                        // and now increase the status line counter and assign a status
                        // line to the agent
                        slc++;
                        war.slc = slc;
                        activeagents.addElement(war);
                        if(debug==true) System.out.println("Added " +war.myactiveobject.getName() +" to activeagents");
                break;

*/
/*

                case Constants.REFLEXWUMPUS:
	                l = envparam[i].length;
	                oname = envparam[i][1];
        	        x = Integer.parseInt(envparam[i][2]); // no of arrows
	                if (l<4) {
                          war = new WumpusAgentReference(new ReflexWumpus(oname, x, envsize));
	                }
	                else {
                          war = new WumpusAgentReference(new ReflexWumpus(oname, x, envsize, envparam[i][3]));
	                }
//                      if (!war.myactiveobject.resname.equals("EMPTY")) {
//                        war.myactiveobject.giveImage(retrieveImage(war.myactiveobject.resname));
//	                }
//                      ((WumpusAgent)(war.myactiveobject)).giveActionImages((Resources)actionimages);
                        if(debug==true) System.out.println("right b4 da problem line field.addObject");
                        field[1][1].addObject((FieldObject)war.myactiveobject);
                        if(debug==true) System.out.println("right after da problem line field.addObject");
                        // and now increase the status line counter and assign a status
                        // line to the agent
                        slc++;
                        war.slc = slc;
                        activeagents.addElement(war);
                        if(debug==true) System.out.println("Added " +war.myactiveobject.getName() +" to activeagents");
                break;

*//*

		case Constants.DUMBWUMPUS:
	                l = envparam[i].length;
	                oname = envparam[i][1];
        	        x = Integer.parseInt(envparam[i][2]); // no of arrows
	                if (l<4) {
                          war = new WumpusAgentReference(new DumbWumpus(oname, x, envsize));
	                }
	                else {
                          war = new WumpusAgentReference(new DumbWumpus(oname, x, envsize, envparam[i][3]));
	                }
//                      if (!war.myactiveobject.resname.equals("EMPTY")) {
//                        war.myactiveobject.giveImage(retrieveImage(war.myactiveobject.resname));
//	                }
//                      ((WumpusAgent)(war.myactiveobject)).giveActionImages((Resources)actionimages);
                        if(debug==true) System.out.println("right b4 da problem line field.addObject");
                        field[1][1].addObject((FieldObject)war.myactiveobject);
                        if(debug==true) System.out.println("right after da problem line field.addObject");
                        // and now increase the status line counter and assign a status
                        // line to the agent
                        slc++;
                        war.slc = slc;
                        activeagents.addElement(war);
                        if(debug==true) System.out.println("Added " +war.myactiveobject.getName() +" to activeagents");
                break;
*/
/*

                case Constants.HASHWUMPUS:
	                l = envparam[i].length;
	                oname = envparam[i][1];
        	        x = Integer.parseInt(envparam[i][2]); // no of arrows
	                if (l<4) {
                          war = new WumpusAgentReference(new HashWumpus(oname, x, envsize));
	                }
	                else {
                          war = new WumpusAgentReference(new HashWumpus(oname, x, envsize, envparam[i][3]));
	                }
//                      if (!war.myactiveobject.resname.equals("EMPTY")) {
//                        war.myactiveobject.giveImage(retrieveImage(war.myactiveobject.resname));
//	                }
//                      ((WumpusAgent)(war.myactiveobject)).giveActionImages((Resources)actionimages);
                        if(debug==true) System.out.println("right b4 da problem line field.addObject");
                        field[1][1].addObject((FieldObject)war.myactiveobject);
                        if(debug==true) System.out.println("right after da problem line field.addObject");
                        // and now increase the status line counter and assign a status
                        // line to the agent
                        slc++;
                        war.slc = slc;
                        activeagents.addElement(war);
                        if(debug==true) System.out.println("Added " +war.myactiveobject.getName() +" to activeagents");
                break;
*/
/*

		case Constants.RESOURCE:
                        Image temp = null;
		        try
		        {
		           temp = toolkit.getImage(new URL(url+envparam[i][2]));
                         ImageFilter fltr= new TransparencyFilter();
                        ImageProducer producer= new FilteredImageSource(temp.getSource(), fltr);
                         temp= toolkit.createImage(producer);
		        }
		        catch (MalformedURLException e1)
		        {
                           if(debug==true) System.out.println("an exception occurred: " + e1.getMessage());
		           e1.printStackTrace();
		        }
                        //Image exchange should come in here
                        //search routine like in retrieve Image
                        //to replace a possibly existing resource
                        //with another
		        imageres.addElement(new ImageReference(envparam[i][1], temp));
                        tracker.addImage(temp, image_id);
		break;
*/

	        default:
                     //do nothing
                     if(debug==true) System.out.println("parameter: " +p +" not recognised !");
                break;
	     } // End switch statement
	   } // End of main_loop: for(i...

          //----- Force all Images to be loaded and wait until-----
          //------they have loaded completely.---------------------
          // for (Enumeration i=imageres.elements(); i.hasMoreElements();)
          // {
          //    ImageReference ir;
          //    ir = (ImageReference) i.nextElement();
              if(debug==true) System.out.println("Loading images...");
              try {
                tracker.waitForID(image_id);
              }
              catch (InterruptedException e1)
              {
                if(debug==true) System.out.println("Error loading images: " + e1.getMessage());
                e1.printStackTrace();
              }
              if (tracker.isErrorID(image_id))
              {
                if(debug==true) System.out.println("Error loading image: " + image_id);
              }

/**/         resloader.checkLoading();


          //-------Initialize Percepts for Agents-----------------------------
           for (Enumeration a=activeagents.elements(); a.hasMoreElements();)
           {
              war = (WumpusAgentReference) a.nextElement();
              generatePercepts(war);
           }
           if(debug==true) System.out.println("leaving WumpusEnvironment Constructor");

   } // End of WumpusEnvironment Contructor


//--------------------------------------------------------------------
	public void doOneStep()
        {
          // Environment and all its Activeagents perform one
          // move each. doOneStep goes through the list of 
          // activeagents and generates a percept for each
          // one and then calls the functions:
          //activeagents.receivePercept(Vector percepts)
          // and then calls  activeagents.sendAction()

          if(debug==true) System.out.println("________________Entering doOneStep...");

          
          Vector dirty_fields = new Vector();
          Vector line_of_fire;
          
          if (this.status[0]==0)
          {
           //Environment not yet finished
           for (Enumeration e=activeagents.elements(); e.hasMoreElements(); )
           {
	      // Ask each active object what it want's to do,
              // and then if it signals a move, check out the 
              // destination field for GOLD and PIT, and providing the
              // destination is not a pit, 
              // check all surrounding fields for a WUMPUS, or for a PIT. 
	      // relative to field (x, y); the neighbouring fields are:- 
	      // (x, y-1) = up; (x, y+1) = down; (x-1, y) = left;
              // (x+1, y) = right;
              // Variables:
              //           WumpusAgentReference: war.
              //           Point: up, down, left, right, center.
              //           Action: newaction.
	      //
	      //
	      //
	      //
              String actiontype;
              Vector tmp;

              if(debug==true) System.out.println("_______Entered doOneStep - the main for loop...");
              WumpusAgentReference war;
              Action newaction;

              war = (WumpusAgentReference) e.nextElement();
              Point up = new Point(war.coord.x, war.coord.y-1);
              Point down = new Point(war.coord.x, war.coord.y+1);
              Point left = new Point(war.coord.x-1, war.coord.y);
              Point right = new Point(war.coord.x+1, war.coord.y);
              Point center = new Point(war.coord.x, war.coord.y);
              Point target = center;
              line_of_fire = new Vector();
	      boolean action_ok = false;
              //flag for the validity of the Agent's requested Action
              
              ((WumpusAgent)war.myactiveobject).receivePercepts(war.newpercepts);
              //give the current agent it's percepts and get it's next Action
              tmp = war.myactiveobject.sendAction();
              field[center.x][center.y].paintAll();
              long ms = System.currentTimeMillis(); //Timer variable
              if (tmp.isEmpty() == true) {
                newaction = new Action("NO_MOVE");
              }
              else {
                newaction = (Action)tmp.firstElement();
              }
              war.history.addElement(newaction);
              //protocol the agent's actions. Necessary ?
              String actn = newaction.getName();
              displayStatus(war); //display the action on the status line
              if (debug==true) {
                System.out.println("processing activeagents: " +war.myactiveobject.getName());
                System.out.println("at field: " +war.coord.x +", "+war.coord.y);
                System.out.println("Sending Percepts:  ");
                for (Enumeration p = war.newpercepts.elements(); p.hasMoreElements();)
                {  String n = ((Percept) p.nextElement()).getName();
                 System.out.print(n +", ");
                }
              } // End if (debug)

              war.newpercepts.removeAllElements();
              if(debug==true) System.out.println();
              if(debug==true) System.out.println("processing action: " +newaction.getName());

              switch(actionToInt(newaction))
	      {
                // Set the target variable according
                // to the action and also set the action type 
		case Constants.UP:
                 target = up;
                 actiontype = "MOVE";
		break;

		case Constants.DOWN:
                 target = down;
                 actiontype = "MOVE";
		break;

		case Constants.LEFT:
                 target = left;
                 actiontype = "MOVE";
		break;

		case Constants.RIGHT:
                 target = right;
                 actiontype = "MOVE";
		break;

		case Constants.SHOOT_UP:
                 for (int y = center.y; (y>0)&!((field[center.x][y].getType()).equalsIgnoreCase("WALL")); y--)
                 {
                     line_of_fire.addElement(new Point(center.x, y));
                 }
                 actiontype = "SHOT";
                 arrow = arrowup;
		break;

		case Constants.SHOOT_DOWN:
                 for (int y = center.y; (y<envsize.height-1)&!((field[center.x][y].getType()).equalsIgnoreCase("WALL")); y++)
                 {
                     line_of_fire.addElement(new Point(center.x, y));
                 }
                 actiontype = "SHOT";
                 arrow = arrowdown;
		break;

		case Constants.SHOOT_LEFT:
                 for (int x = center.x; (x>0)&!((field[x][center.y].getType()).equalsIgnoreCase("WALL")); x--)
                 {
                     line_of_fire.addElement(new Point(x, center.y));
                 }
                 actiontype = "SHOT";
                 arrow = arrowleft;
		break;

		case Constants.SHOOT_RIGHT:
                 for (int x = center.x; (x<envsize.width-1)&!((field[x][center.y].getType()).equalsIgnoreCase("WALL")); x++)
                 {
                     line_of_fire.addElement(new Point(x, center.y));
                 }
                 actiontype = "SHOT";
                 arrow = arrowright;
		break;

		case Constants.GRAB:
                 actiontype = "GRAB";
		break;

		default:
                case Constants.INVALID_MOVE:
                actiontype = "INVALID_MOVE";
                break;

		case Constants.CLIMB:
		 // i.e. a CLIMB percept has been generated
                 actiontype = "CLIMB";
		break;

              } // End switch(...


              //-------switch 2-------------------------------------
              //
              if(debug==true) System.out.println("actiontype: " +actiontype);
              switch (actiontypeToInt(actiontype))
	      {
		case Constants.MOVE:
                  // Assume that the move was succesful and set the agent's
                  // coordinates to the target field. If agent runs into a
                  // wall, reset the coordinates to the old one.

                  if(debug==true) System.out.println("case MOVE");
                  ((WumpusAgent)war.myactiveobject).updateScore(Constants.MOVEVALUE);
                  dirty_fields.addElement(center);
                  war.coord = target; // set  coord to new point
                  String type = field[target.x][target.y].getType();

                  switch(typeToInt(type)) {
		     	case Constants.WALL:
                          war.coord = center;
                          //Exception: walls can't hold anything therefore
                          //reset coord to old point
                          war.newpercepts.addElement(new Percept("BUMP"));
		     	break;

		     	case Constants.PIT:
			  action_ok = true;
                          war.moves++;
                          field[center.x][center.y].removeObject((FieldObject)war.myactiveobject);
                          field[target.x][target.y].addObject(war.myactiveobject);
                          dirty_fields.addElement(new Point(target.x, target.y));
                          war.newpercepts.addElement(new Percept("FALL"));
                          ((WumpusAgent)war.myactiveobject).setStatus("Dead", "PIT");
                          ((WumpusAgent)war.myactiveobject).setScore(Constants.DEATHVALUE);
                          war.cause_of_death = "PIT";
                          inactiveagents.addElement(war);
                          activeagents.removeElement(war);
                        break;
		     
		     	default:
                        //Unknown field type. Do Nothing ?
                        break;

		     	case Constants.SPACE:
                        case Constants.EXIT:
 			  action_ok = true;
                          war.moves++;
                          field[center.x][center.y].removeObject((FieldObject)war.myactiveobject);
                          field[target.x][target.y].addObject(war.myactiveobject);
                          dirty_fields.addElement(new Point(target.x, target.y));
                          boolean agent_dead = false;   
                          fldobjlist = field[target.x][target.y].getObjectList();
                          if(debug==true) System.out.println("case SPACE");
                          if(debug==true) System.out.println("fldobjlist.length =" +fldobjlist.length);
                          //------------for... loop-----------------------------
                          for (int d = 0;(d<fldobjlist.length)&(agent_dead == false); d++)
                          {
                              String s = fldobjlist[d].getType();
                              FieldObject fo = fldobjlist[d];
                              if (fo instanceof Wumpus)
                              {
                                  if (((Wumpus)(fo)).getStatus() == true)
                                  {
                                     agent_dead = true;
                                   if(debug==true) System.out.print("Wumpus found at: ");
                                   if(debug==true) System.out.println(target.x+", "+target.y);
                                  }
                               }
                          } //End for

                          if (agent_dead != true)
                          {
                               if(debug==true) System.out.print(war.myactiveobject.getName()+" Hops on Field:");
                               if(debug==true) System.out.print(target.x +", " +target.y);
                               if(debug==true) System.out.print("\n");
                          }
                          else {
                               if(debug==true) System.out.println("case =WUMPUS");
                               war.newpercepts.addElement(new Percept("GOBBLE"));
                               war.cause_of_death = "WUMPUS";
                               inactiveagents.addElement(war);
                               activeagents.removeElement(war);
                               ((WumpusAgent)war.myactiveobject).setStatus("Dead", "WUMPUS");
                               ((WumpusAgent)war.myactiveobject).setScore(Constants.DEATHVALUE);
                               if(debug==true) System.out.print(war.myactiveobject.getName()+ " becomes lunch for wumpus at:");
                               if(debug==true) System.out.print(target.x +", " +target.y);
                               if(debug==true) System.out.print("\n");
                           }
                        break;
                  }
                break; // end case Constants.MOVE

		case Constants.SHOT:
		  // check if agent has an arrow to fire, then check through
		  // the field's list of fieldobjects and if there is a Wumpus,
                  //  remove it and generate a SCREAM percept for ALL active
                  // agents.
                  if(debug==true) System.out.println("case SHOT");
                  ((WumpusAgent)war.myactiveobject).updateScore(Constants.MOVEVALUE);
                  boolean wumpus_dead = false;
                  if (((WumpusAgent) war.myactiveobject).arrowsLeft() == true) 
		  {
  		      action_ok = true;
                      if(debug==true) System.out.println("Arrow Fired!");
                     ((WumpusAgent)war.myactiveobject).reduceArrows();
                     Enumeration f;
                     for (f=line_of_fire.elements();(f.hasMoreElements())&(wumpus_dead==false);)
                     {      
                       target = (Point) f.nextElement();
                       fldobjlist = field[target.x][target.y].getObjectList();
                       for (int c = 0;(c< fldobjlist.length)&(wumpus_dead==false); c++)
                       {
                         type = fldobjlist[c].getType();
                         FieldObject fo = fldobjlist[c];
                         if (fo instanceof Wumpus)
                         {
			     if (((Wumpus) fo).getStatus()==true)
			     {
                               //-*-war.newpercepts.addElement(new Percept("SCREAM"));
                               // all active agents get scream Percept
                               for (Enumeration all=activeagents.elements(); all.hasMoreElements(); )
                               {
                                 WumpusAgentReference warscream = (WumpusAgentReference)all.nextElement();
                                 warscream.newpercepts.addElement(new Percept("SCREAM"));
                               }
                               ((WumpusAgent)war.myactiveobject).updateScore(Constants.WUMPUSVALUE);
                               ((Wumpus)(fldobjlist[c])).setStatus("DEAD");
                               dirty_fields.addElement(new Point(target.x, target.y));
                               wumpus_dead = true;
                               if(debug==true) System.out.print(war.myactiveobject.getName() +" Kills Wumpus:" +fldobjlist[c].getName());
                               if(debug==true) System.out.print("at Field:" +target.x +", " +target.y);
                               if(debug==true) System.out.print("\n");
                             } //End if (((Wumpus) fo).getStatus()==true)
                         } // End if (fo instanceof Wumpus...
                       } // End for (int c = 0; ...

                       // Animation of arrow (test)
                       Point temp = null;
                       for (int envlimit =0; envlimit < envsize.width*envsize.height; envlimit++ )
                       {
                          if (fieldcoords[envlimit][0].equals(target))
                          {
                               temp = fieldcoords[envlimit][1];
                               //physical Field coordinates in pixels
                          }
                       }
                       g.drawImage(arrow, temp.x, temp.y, arrowlength, arrowlength, null);
                       ms = System.currentTimeMillis();
                       while (ms+Constants.PAUSEVALUE > System.currentTimeMillis());
                       //pause
                       field[target.x][target.y].paintAll();
                     } //End for (Enum.. f
		  } //
		break;

                case Constants.GRAB:
		  // check through the field's list of fieldobjects and if there is 
		  // a piece of gold, remove it and update the Agent's score
                  if(debug==true) System.out.println("case GRAB");
		  fldobjlist = field[center.x][center.y].getObjectList();
                  boolean hurrah = false;
                  for (int c = 0;(c< fldobjlist.length)&(hurrah==false); c++)
                  {
		    type = fldobjlist[c].getType();
                    FieldObject fo = fldobjlist[c];
                    if (fo instanceof Gold)
                    {
			action_ok = true;
                        field[center.x][center.y].removeObject((FieldObject)fldobjlist[c]);
                        ((WumpusAgent)war.myactiveobject).updateScore(Constants.GOLDVALUE);
                        dirty_fields.addElement(center);
                        hurrah = true;
                        if(debug==true) System.out.print(war.myactiveobject.getName() +" Grabs Gold at Field:");
                        if(debug==true) System.out.println(center.x +", " +center.y);
                    } // End if (type.equalsIgnoreCase("GOLD...
                  } // End for (int c = 0; ...
                  if (hurrah = false) ((WumpusAgent)war.myactiveobject).updateScore(Constants.MOVEVALUE);
		break;

                case Constants.CLIMB:
                  if(debug==true) System.out.println("case CLIMB");
                  if ((field[center.x][center.y].getType()).equals("EXIT")) {
                        ((WumpusAgent)war.myactiveobject).setStatus("Dead", "Exit");
		       action_ok = true;
                       war.cause_of_death = "EXIT";
                       inactiveagents.addElement(war);
                       activeagents.removeElement(war);
                       //field[center.x][center.y].removeObject(war.myactiveobject);
                       // Agent does NOT disappear from field.
                       dirty_fields.addElement(center);
		  }
                  else 
                    ((WumpusAgent)war.myactiveobject).updateScore(Constants.MOVEVALUE);
		break;

		default:
                case Constants.INVALID_MOVE:
                  //Do nothing
                  if(debug==true) System.out.println("case default/Invalid move");
                  //((WumpusAgent)war.myactiveobject).updateScore(Constants.MOVEVALUE);
                  if(debug==true) System.out.println("Move: " +actiontype +" not recognised !");
                  //not a valid move
		break;

              } //-------End Switch 2-------------------------------------


              if(debug==true) System.out.println("finished processing activeagent: " +war.myactiveobject.getName());
              ((WumpusAgent)(war.myactiveobject)).actionOK(action_ok);
	      while (ms+1000> System.currentTimeMillis());
	      field[center.x][center.y].paintAll();
	      field[target.x][target.y].paintAll();
           } //End for(Enumeration e ...
           //-----------------All Agents have been processed------------------

           end:
           // At this point all active agents have made their moves 
           // and gotten some percepts.display the inactive agents
           // and give the remaining percepts.

           // now for the inactive objects to be displayed on the status line
/*           Enumeration i;
           for (i=inactiveagents.elements(); i.hasMoreElements(); )
           {
             WumpusAgentReference war = (WumpusAgentReference)i.nextElement();
             displayStatus(war);
           }

           // repaint all fields involved in moves
              for (Enumeration p=dirty_fields.elements(); p.hasMoreElements(); )
              {
                Point dirty = (Point) p.nextElement();
                field[dirty.x][dirty.y].paintAll();
              }
*/

              paint(dirty_fields);
              //-Generate Percepts for Agents---
              for (Enumeration p=activeagents.elements(); p.hasMoreElements(); )
              {
                WumpusAgentReference war;
                war = (WumpusAgentReference) p.nextElement();
                generatePercepts(war);
              }
              // check if all agents are still active else set the
              // Environment status to finished
              boolean finished = activeagents.isEmpty();
              if (finished == true)
              {
                   this.status[0] = 1;
                   if(debug==true) System.out.println("Environment:" +this.name +" is finished");
                   paintAll();
              } //End if (finished
          } // End if (this.status[0]==0)
	  else {
                paintAll();
	  }

        if(debug==true) System.out.println("___________leaving doOneStep - main loop. after running paintAlls");
	} //End of doOneStep()


//--------------------------------------------------------------------------------

//----Helper Functions------------------------------------

 public Image retrieveImage(String s) {
     Image temp = null;
     ImageReference irtemp;
     for (Enumeration ir=imageres.elements(); ir.hasMoreElements();)
     {
         irtemp = (ImageReference) ir.nextElement();
         if (s.equals(irtemp.name)) {
                 temp = irtemp.image;
         }
     } // End Enumeration
     if (temp==null) {
        try
        {
           temp = toolkit.getImage(new URL(url+s));
        }
        catch (MalformedURLException e1)
        {
           if(debug==true) System.out.println("an exception occurred: " + e1.getMessage());
           e1.printStackTrace();
        }

        ImageFilter fltr = new TransparencyFilter();
        ImageProducer producer = new FilteredImageSource(temp.getSource(), fltr);
        temp = toolkit.createImage(producer);

        irtemp = new ImageReference(s, temp);
        imageres.addElement(irtemp);
        tracker.addImage(temp, image_id);
        //testing..
        /*try tracker.waitForID(image_id);
        catch (InterruptedException e1)
        {
          if(debug==true) System.out.println("Image load error: " + e1.getMessage());
           e1.printStackTrace();
        } */
        
     } // End if (temp==null)

     return temp;
 } // End retrieveImage()

 public final static int actionToInt(Action a) {
        String s = a.getName();
        if(debug==true) System.out.println("entered actionToInt: ");
        if(debug==true) System.out.println("actionname = : "+s);

        if (s.equalsIgnoreCase("Up")) return Constants.UP;
        if (s.equalsIgnoreCase("Down")) return Constants.DOWN;
        if (s.equalsIgnoreCase("Left")) return Constants.LEFT;
        if (s.equalsIgnoreCase("Right")) return Constants.RIGHT;
        if (s.equalsIgnoreCase("Shoot_Up")) return Constants.SHOOT_UP;
        if (s.equalsIgnoreCase("Shoot_Down")) return Constants.SHOOT_DOWN;
        if (s.equalsIgnoreCase("Shoot_Left")) return Constants.SHOOT_LEFT;
        if (s.equalsIgnoreCase("Shoot_Right")) return Constants.SHOOT_RIGHT;
        if (s.equalsIgnoreCase("Grab")) return Constants.GRAB;
        if (s.equalsIgnoreCase("Climb")) return Constants.CLIMB;
        return Constants.INVALID_MOVE;
 } // End actionToInt()

 public final static int typeToInt(String s) {
        if (s.equals("WALL")) return Constants.WALL;
        if (s.equals("SPACE")) return Constants.SPACE;
        if (s.equals("PIT")) return Constants.PIT;
        if (s.equals("EXIT")) return Constants.EXIT;
        return Constants.SPACE;  //default
 } //End typeToInt

 public final static int actiontypeToInt(String s) {
        if (s.equals("MOVE")) {
                if(debug==true) System.out.println("actiontypeToInt() returns MOVE");
                return Constants.MOVE;
        }
        if (s.equals("SHOT")) {
                if(debug==true) System.out.println("actiontypeToInt() returns SHOT");
                return Constants.SHOT;
        }
        if (s.equals("GRAB")) {
                if(debug==true) System.out.println("actiontypeToInt() returns GRAB");
                return Constants.GRAB;
        }
        if (s.equals("CLIMB")) {
                if(debug==true) System.out.println("actiontypeToInt() returns CLIMB");
                return Constants.CLIMB;
        }
        return Constants.INVALID_MOVE;  //default
 }

 public final static int paramToInt(String s) {
        if(debug==true) System.out.println("entered paramToInt");
        if(debug==true) System.out.println("s=" +s +"<-");
        if (s.equals("20")) return Constants.WUMPUS;
        if (s.equals("22")) return Constants.GOLD;
        if (s.equals("24")) return Constants.AGENT;
//        if (s.equals("26")) return Constants.DUMBWUMPUS;
        if (s.equals("28")) return Constants.FIELDS;
        return Constants.GOLD;
 }

//-----End Helper Functions---------------------------------

 public void generatePercepts(WumpusAgentReference war) {
     //-------Generate Percepts for a given Agent----------------
     // First, go through the current fields list of fieldobjects
     // and generate new percepts
         if(debug==true) System.out.println("____Entering generatePercepts()");
         Point ct = new Point(war.coord.x, war.coord.y);
         if(debug==true) System.out.println("war.coord: "+ct.x+", "+ct.y);
         fldobjlist = field[ct.x][ct.y].getObjectList();
         if(debug==true) System.out.println("fldobjlist.length =" +fldobjlist.length);
         //------------for... loop-----------------------------
         for (int d = 0; d < fldobjlist.length; d++)
         {
           if(debug==true) System.out.println("d =" +d+"<-");
           String type = fldobjlist[d].getType();
           if(debug==true) System.out.println("type =" +type+"<-");
           if (type.equalsIgnoreCase("DumbWumpus")) {
              // do nothing
              if(debug==true) System.out.println("case =DUMBWUMPUS");
           }

           if (type.equalsIgnoreCase("GOLD")) {
              if(debug==true) System.out.println("case =GOLD");
              war.newpercepts.addElement(new Percept("GLITTER"));
           } // end if type.equalsIgnoreCase(gold)
         } // End for (int d = 0...

         // Now go through the surrounding fields (up, down left, right) and
         // check for a wumpus or a pit, the only objects which can be sensed
         // from a neighbouring field

         WumpusField up = field[ct.x][ct.y -1];
         WumpusField down = field[ct.x][ct.y + 1];
         WumpusField left = field[ct.x - 1][ct.y];
         WumpusField right = field[ct.x + 1][ct.y];
         WumpusField[] neighbour = {up, down, left, right};
          if(debug==true) System.out.println("checking surrounding fields... ");
          for (int c = 0; c < 4; c++)
          {
            String type = neighbour[c].getType();
            if(debug==true) System.out.println("fieldtype: " +type);
            switch(typeToInt(type)) {
               case Constants.SPACE:
                    if(debug==true) System.out.println("SPACE");
                    fldobjlist = neighbour[c].getObjectList();
                    for (int d = 0; d< fldobjlist.length; d++) {
                       String t = fldobjlist[d].getType();
                       FieldObject fo = fldobjlist[d];
                       if (fo instanceof Wumpus) {
                            war.newpercepts.addElement(new Percept("STENCH"));
                       } // End if
                       if(debug==true) System.out.println("fieldobject: " +t +"<-");
                    } //End for (int d=0; d<...
               break;

               case Constants.PIT:
                   war.newpercepts.addElement(new Percept("BREEZE"));
                   if(debug==true) System.out.println("case: PIT");
               break;

               default:
               case Constants.EXIT:
               case Constants.WALL:
                   //do nothing
                   if(debug==true) System.out.println("case: default/EXIT/WALL");
               break;
            } //End switch(t)
          } //End for (int c = 0; c < 3; c++)
         if(debug==true) System.out.println("____Leaving generatePercepts()");

 }


//--------------------------------------------------------------------------------
	public void setArea(Rectangle newarea, Graphics parentg) {
	// Creates a new Graphics g object from the parentg,
	// having the dimension specified in newarea
           if(debug==true) System.out.println("running setArea");
	   grect = newarea;
	   g = parentg.create(grect.x, grect.y, grect.width, grect.height);
           if(debug==true) System.out.println("Environment.grect.width= "+ grect.width);
           if(debug==true) System.out.println("    grect.height= "+grect.height);
           //environmentPaintAll(); 
           
           Rectangle totalrect;
           totalrect =new Rectangle(2, 20, grect.width-4, grect.height-20-60);
           // height -20 pixels for the Name of the Environment
           //        -39 pixels for the 3 status lines  13 pixels

	   int xfactor = totalrect.width / envsize.width;
           int yfactor = totalrect.height / envsize.height;
           xfactor = Math.min(xfactor, yfactor);
           totalrect = new Rectangle(totalrect.x, totalrect.y, xfactor, xfactor);
	   Rectangle fieldrect;
           fieldcoords = new Point[envsize.width*envsize.height][2];
           int fcc = 0;
           // fieldcoords[x][0] = field's position in the environment;
           // fieldcoords[x][1] = fields screen coords in pixels;
           // fcc - fieldcoords counter;

	   // this loop creates a rectangle for each field which represents
           // that field's drawing area, and passes it to the field along
           // with the environments Graphics object.
	   for (int y = 0; y < envsize.height; y++)
	   {
		for (int x = 0; x < envsize.width; x++)
		{
                   int a, b, c, d;
                   a = x * xfactor+2;
                   b = y * xfactor +20;
                   c = xfactor;
                   d = xfactor; 

                   fieldrect = new Rectangle(a, b, c, d);
		   field[x][y].setArea(fieldrect, g);
                   fieldcoords[fcc][0] = new Point(x, y);
                   fieldcoords[fcc][1] = new Point(a+(c/4), b+(d/4));
                   arrowlength = c/2;
                   fcc++;
                   //field[x][y].paintAll();
		} // End of for (int x...
	   } // End of for (int i...
           paintAll();
           if(debug==true) System.out.println("leaving Environment.setArea");
	} // End of setArea()

//--------------------------------------------------------------------------------
        void paint() {
           paint(new Vector());
        }

        void paint(Vector dirty_fields) {
        // This paint function paints only specified fields anew
        // and makes sure inactive objects are displayed

        // repaint all fields involved in moves
           if(debug==true) System.out.println("running fieldPaintAll()...");
           for (Enumeration p=dirty_fields.elements(); p.hasMoreElements(); )
           {
             Point dirty = (Point) p.nextElement();
             field[dirty.x][dirty.y].paintAll();
           }

         // Display inactive objects on the status line
           Enumeration i;
           for (i=inactiveagents.elements(); i.hasMoreElements(); )
           {
             WumpusAgentReference war = (WumpusAgentReference)i.nextElement();
             displayStatus(war);
           }

         // Display active objects on the status line
           Enumeration j;
           for (j=activeagents.elements(); j.hasMoreElements(); )
           {
             WumpusAgentReference war = (WumpusAgentReference)j.nextElement();
             displayStatus(war);
           }

        } // End of Function paint()

//--------------------------------------------------------------------------------
	public void paintAll() {
	   // draws the Environment and starts the 
	   // paintAll of all it's fields
           try {
             tracker.waitForAll(5000);
           }
           catch (InterruptedException e1)
           {
             if(debug==true) System.out.println("Image load error: " + e1.getMessage());
             e1.printStackTrace();
           }

	   environmentPaintAll();
           paint();
           fieldPaintAll(); 
           toolkit.sync(); //flush pending graphics output

	}// End of paintAll()
	
//--------------------------------------------------------------------------------
	private void environmentPaintAll() {
           if(debug==true) System.out.println("entering environmentPaintAll()");
	   Color foreground = new Color(220, 80, 100);
	   g.setColor(foreground);
           g.clearRect(0, 0, grect.width, grect.height-1);
           g.drawRect(0, 0, grect.width-1, grect.height-1);
           Font f = g.getFont();
           Font f1 = new Font("Arial", 1, 15);
           g.setFont(f1);
           g.drawString(this.name, 5, 18);
           g.setFont(f);
	}

//--------------------------------------------------------------------------------
	private void fieldPaintAll() {
           if(debug==true) System.out.println("entering fieldPaintAll()");
	   for (int y = 0; y < envsize.height; y++)
	   {
		for (int x = 0; x < envsize.width; x++)
		{
			field[x][y].paintAll();
		} // End of for (int x...
	   } // End of for (int y...
           if(debug==true) System.out.println("leaving fieldPaintAll()");
        } //End fieldPaintAll()

//--------------------------------------------------------------------------------
        void displayStatus(WumpusAgentReference arg) {
           // At the Moment this Function only caters for max of 3 agents
	   Color foreground = new Color(220, 80, 100);
	   g.setColor(foreground);
           Font f = g.getFont();
           Font f1 = new Font("Arial", 1, 11);
           g.setFont(f1);
           WumpusAgentReference war = arg;
           int l = war.slc;
           int score = ((WumpusAgent)war.myactiveobject).getScore();
           Rectangle rect;
           String cod = war.cause_of_death;
          
           String n = war.myactiveobject.getName();
           String msg = n+": "+Integer.toString(score)+"  "+cod;

           switch(l) {
                case 1:
                   // Status line 1
                   g.clearRect(2, grect.height-60, grect.width-3,20);
                   rect = new Rectangle(2, grect.height-60, 20, 20);
                   ((WumpusAgent)war.myactiveobject).draw(g, rect);
                   //g.drawString(n+": "+msg, 2, grect.height-32);
	           g.setColor(foreground);
                   g.drawString(msg, 22, grect.height-41);
                break;

                case 2:
                   // Status line 2
                   g.clearRect(2, grect.height-40, grect.width-3,20);
                   rect = new Rectangle(2, grect.height-40, 20, 20);
                   ((WumpusAgent)war.myactiveobject).draw(g, rect);
	           g.setColor(foreground);
                   g.drawString(msg, 22, grect.height-21);
                break;

                case 3:
                   // Status line 3
                   g.clearRect(2, grect.height-20, grect.width-3,19);
                   rect = new Rectangle(2, grect.height-20, 20, 20);
                   ((WumpusAgent)war.myactiveobject).draw(g, rect);
	           g.setColor(foreground);
                   g.drawString(msg, 22, grect.height-1);
                break;
           }
           g.setFont(f);
        } //End displayStatus(...


//---------------------------------------------------------------------------
	public Dimension getMinSize() {
           int x,y;
           Dimension minimumsize;

           x = 40*envsize.width;
           y = 40*envsize.height;
           minimumsize = new Dimension(x+5, y+5+20+39);
           //5 pixels extra for a teeny bit of space all around the sides
           // y+20 - 20 pixels extra for the environment's name display
           // y+39 - 39 pixels extra for the status line displays
           return minimumsize;
	}


//--------------------------------------------------------------------------------
	protected void finalize()  throws Throwable
        {
	// Garbage collection

           for (int y = 0; y < envsize.height; y++) {
              for (int x = 0; x < envsize.width; x++) {
                 field[x][y].finalize();
              }
           }

           // get rid of environments own Graphics object
           tracker = null;
           toolkit = null;
           g.finalize();
           super.finalize();
	}


} // End of Class WumpusEnvironment

